/* DuplicityJob.c generated by valac 0.44.3, the Vala compiler
 * generated from DuplicityJob.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>

typedef enum  {
	GPG_ERR_NO_SECKEY = 17,
	GPG_ERR_BAD_KEY = 19
} gpg_err_code_t;

#define DEJA_DUP_TYPE_TOOL_JOB (deja_dup_tool_job_get_type ())
#define DEJA_DUP_TOOL_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_TOOL_JOB, DejaDupToolJob))
#define DEJA_DUP_TOOL_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_TOOL_JOB, DejaDupToolJobClass))
#define DEJA_DUP_IS_TOOL_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_TOOL_JOB))
#define DEJA_DUP_IS_TOOL_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_TOOL_JOB))
#define DEJA_DUP_TOOL_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_TOOL_JOB, DejaDupToolJobClass))

typedef struct _DejaDupToolJob DejaDupToolJob;
typedef struct _DejaDupToolJobClass DejaDupToolJobClass;
typedef struct _DejaDupToolJobPrivate DejaDupToolJobPrivate;

#define TYPE_DUPLICITY_JOB (duplicity_job_get_type ())
#define DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_JOB, DuplicityJob))
#define DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_JOB, DuplicityJobClass))
#define IS_DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_JOB))
#define IS_DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_JOB))
#define DUPLICITY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_JOB, DuplicityJobClass))

typedef struct _DuplicityJob DuplicityJob;
typedef struct _DuplicityJobClass DuplicityJobClass;
typedef struct _DuplicityJobPrivate DuplicityJobPrivate;
typedef enum  {
	DEJA_DUP_TOOL_JOB_MODE_INVALID,
	DEJA_DUP_TOOL_JOB_MODE_BACKUP,
	DEJA_DUP_TOOL_JOB_MODE_RESTORE,
	DEJA_DUP_TOOL_JOB_MODE_STATUS,
	DEJA_DUP_TOOL_JOB_MODE_LIST,
	DEJA_DUP_TOOL_JOB_MODE_HISTORY
} DejaDupToolJobMode;

#define DEJA_DUP_TOOL_JOB_TYPE_MODE (deja_dup_tool_job_mode_get_type ())
typedef enum  {
	DUPLICITY_JOB_STATE_NOT_STARTED,
	DUPLICITY_JOB_STATE_NORMAL,
	DUPLICITY_JOB_STATE_DRY_RUN,
	DUPLICITY_JOB_STATE_STATUS,
	DUPLICITY_JOB_STATE_CHECK_CONTENTS,
	DUPLICITY_JOB_STATE_CLEANUP,
	DUPLICITY_JOB_STATE_DELETE
} DuplicityJobState;

#define DUPLICITY_JOB_TYPE_STATE (duplicity_job_state_get_type ())

#define TYPE_DUPLICITY_INSTANCE (duplicity_instance_get_type ())
#define DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstance))
#define DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))
#define IS_DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_INSTANCE))
#define IS_DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_INSTANCE))
#define DUPLICITY_INSTANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))

typedef struct _DuplicityInstance DuplicityInstance;
typedef struct _DuplicityInstanceClass DuplicityInstanceClass;

#define DUPLICITY_JOB_TYPE_DATE_INFO (duplicity_job_date_info_get_type ())
typedef struct _DuplicityJobDateInfo DuplicityJobDateInfo;
enum  {
	DUPLICITY_JOB_0_PROPERTY,
	DUPLICITY_JOB_STATE_PROPERTY,
	DUPLICITY_JOB_NUM_PROPERTIES
};
static GParamSpec* duplicity_job_properties[DUPLICITY_JOB_NUM_PROPERTIES];

#define DEJA_DUP_TYPE_NETWORK (deja_dup_network_get_type ())
#define DEJA_DUP_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_NETWORK, DejaDupNetwork))
#define DEJA_DUP_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_NETWORK, DejaDupNetworkClass))
#define DEJA_DUP_IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_NETWORK))
#define DEJA_DUP_IS_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_NETWORK))
#define DEJA_DUP_NETWORK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_NETWORK, DejaDupNetworkClass))

typedef struct _DejaDupNetwork DejaDupNetwork;
typedef struct _DejaDupNetworkClass DejaDupNetworkClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DEJA_DUP_TYPE_BACKEND (deja_dup_backend_get_type ())
#define DEJA_DUP_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackend))
#define DEJA_DUP_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))
#define DEJA_DUP_IS_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_IS_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))

typedef struct _DejaDupBackend DejaDupBackend;
typedef struct _DejaDupBackendClass DejaDupBackendClass;

#define DEJA_DUP_TYPE_FILTERED_SETTINGS (deja_dup_filtered_settings_get_type ())
#define DEJA_DUP_FILTERED_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettings))
#define DEJA_DUP_FILTERED_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettingsClass))
#define DEJA_DUP_IS_FILTERED_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS))
#define DEJA_DUP_IS_FILTERED_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_FILTERED_SETTINGS))
#define DEJA_DUP_FILTERED_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_FILTERED_SETTINGS, DejaDupFilteredSettingsClass))

typedef struct _DejaDupFilteredSettings DejaDupFilteredSettings;
typedef struct _DejaDupFilteredSettingsClass DejaDupFilteredSettingsClass;
typedef enum  {
	DEJA_DUP_TOOL_JOB_FLAGS_NO_PROGRESS,
	DEJA_DUP_TOOL_JOB_FLAGS_NO_CACHE
} DejaDupToolJobFlags;

#define DEJA_DUP_TOOL_JOB_TYPE_FLAGS (deja_dup_tool_job_flags_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DuplicityJobAsyncSetupData DuplicityJobAsyncSetupData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _DuplicityJobReportFullBackupsData DuplicityJobReportFullBackupsData;
typedef struct _DuplicityJobCheckBackupSpaceData DuplicityJobCheckBackupSpaceData;

#define DEJA_DUP_TYPE_RECURSIVE_OP (deja_dup_recursive_op_get_type ())
#define DEJA_DUP_RECURSIVE_OP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_RECURSIVE_OP, DejaDupRecursiveOp))
#define DEJA_DUP_RECURSIVE_OP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_RECURSIVE_OP, DejaDupRecursiveOpClass))
#define DEJA_DUP_IS_RECURSIVE_OP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_RECURSIVE_OP))
#define DEJA_DUP_IS_RECURSIVE_OP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_RECURSIVE_OP))
#define DEJA_DUP_RECURSIVE_OP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_RECURSIVE_OP, DejaDupRecursiveOpClass))

typedef struct _DejaDupRecursiveOp DejaDupRecursiveOp;
typedef struct _DejaDupRecursiveOpClass DejaDupRecursiveOpClass;

#define DEJA_DUP_TYPE_RECURSIVE_DELETE (deja_dup_recursive_delete_get_type ())
#define DEJA_DUP_RECURSIVE_DELETE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_RECURSIVE_DELETE, DejaDupRecursiveDelete))
#define DEJA_DUP_RECURSIVE_DELETE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_RECURSIVE_DELETE, DejaDupRecursiveDeleteClass))
#define DEJA_DUP_IS_RECURSIVE_DELETE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_RECURSIVE_DELETE))
#define DEJA_DUP_IS_RECURSIVE_DELETE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_RECURSIVE_DELETE))
#define DEJA_DUP_RECURSIVE_DELETE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_RECURSIVE_DELETE, DejaDupRecursiveDeleteClass))

typedef struct _DejaDupRecursiveDelete DejaDupRecursiveDelete;
typedef struct _DejaDupRecursiveDeleteClass DejaDupRecursiveDeleteClass;

#define DEJA_DUP_TYPE_BACKEND_S3 (deja_dup_backend_s3_get_type ())
#define DEJA_DUP_BACKEND_S3(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3))
#define DEJA_DUP_BACKEND_S3_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3Class))
#define DEJA_DUP_IS_BACKEND_S3(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND_S3))
#define DEJA_DUP_IS_BACKEND_S3_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND_S3))
#define DEJA_DUP_BACKEND_S3_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3Class))

typedef struct _DejaDupBackendS3 DejaDupBackendS3;
typedef struct _DejaDupBackendS3Class DejaDupBackendS3Class;

struct _DejaDupToolJob {
	GObject parent_instance;
	DejaDupToolJobPrivate * priv;
	GList* includes;
	GList* excludes;
	GList* exclude_regexps;
	GList* _restore_files;
};

struct _DejaDupToolJobClass {
	GObjectClass parent_class;
	void (*start) (DejaDupToolJob* self);
	void (*cancel) (DejaDupToolJob* self);
	void (*stop) (DejaDupToolJob* self);
	void (*pause) (DejaDupToolJob* self, const gchar* reason);
	void (*resume) (DejaDupToolJob* self);
};

struct _DuplicityJob {
	DejaDupToolJob parent_instance;
	DuplicityJobPrivate * priv;
};

struct _DuplicityJobClass {
	DejaDupToolJobClass parent_class;
	void (*process_error) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text_in);
	void (*process_info) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text);
	void (*process_warning) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text);
};

struct _DuplicityJobDateInfo {
	gboolean full;
	GTimeVal time;
};

struct _DuplicityJobPrivate {
	DejaDupToolJobMode _original_mode;
	gboolean _error_issued;
	gboolean _was_stopped;
	DuplicityJobState _state;
	DuplicityInstance* inst;
	GList* backend_argv;
	GList* saved_argv;
	GList* saved_envp;
	gboolean is_full_backup;
	gboolean cleaned_up_once;
	gboolean needs_root;
	gboolean detected_encryption;
	gboolean existing_encrypted;
	gchar* last_bad_volume;
	guint bad_volume_count;
	gboolean has_progress_total;
	guint64 progress_total;
	guint64 progress_count;
	gboolean has_checked_contents;
	gboolean has_non_home_contents;
	GList* homes;
	GList* local_error_files;
	gboolean checked_collection_info;
	gboolean got_collection_info;
	GList* collection_info;
	gboolean reported_full_backups;
	gboolean checked_backup_space;
	gboolean deleted_files;
	gint delete_age;
	GFile* last_touched_file;
	gchar* forced_cache_dir;
	gchar* saved_status;
	GFile* saved_status_file;
	gboolean saved_status_file_action;
	gboolean restarted_without_cache;
};

struct _DuplicityJobAsyncSetupData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	DejaDupToolJobFlags _tmp0_;
	DejaDupToolJobFlags _tmp1_;
	gchar* template;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	DejaDupBackend* _tmp9_;
	DejaDupBackend* _tmp10_;
	DejaDupBackend* _tmp11_;
	DejaDupBackend* _tmp12_;
	GError* e;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError* _inner_error0_;
};

struct _DuplicityJobReportFullBackupsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	GDate full_backup;
	GList* _tmp0_;
	GList* info_collection;
	GList* info_it;
	DuplicityJobDateInfo info;
	DuplicityJobDateInfo _tmp1_;
	DuplicityJobDateInfo _tmp2_;
	GTimeVal _tmp3_;
	gboolean first_backup;
	gboolean do_restart;
	DejaDupBackend* delete_backend;
	DejaDupBackend* _tmp4_;
	DejaDupBackend* _tmp5_;
	DejaDupBackend* _tmp6_;
	DejaDupBackend* _tmp7_;
	DejaDupBackend* _tmp8_;
	GDate threshold;
	GDate _tmp9_;
	gboolean _tmp10_;
	GDate _tmp11_;
	gboolean _tmp12_;
};

struct _DuplicityJobCheckBackupSpaceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	gchar* formatted_progress_total;
	gchar* _tmp0_;
	guint64 free;
	DejaDupBackend* _tmp1_;
	DejaDupBackend* _tmp2_;
	guint64 total;
	DejaDupBackend* _tmp3_;
	DejaDupBackend* _tmp4_;
	gboolean _tmp5_;
	gchar* msg;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint full_dates;
	GList* _tmp11_;
	GList* info_collection;
	GList* info_it;
	DuplicityJobDateInfo info;
	DuplicityJobDateInfo _tmp12_;
	gchar* _vala1_msg;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
};

static gint DuplicityJob_private_offset;
static gpointer duplicity_job_parent_class = NULL;
static GFile* duplicity_job_slash;
static GFile* duplicity_job_slash = NULL;
static GFile* duplicity_job_slash_root;
static GFile* duplicity_job_slash_root = NULL;
static GFile* duplicity_job_slash_home;
static GFile* duplicity_job_slash_home = NULL;
static GFile* duplicity_job_slash_home_me;
static GFile* duplicity_job_slash_home_me = NULL;
extern guint64 deja_dup_backend_INFINITE_SPACE;

const gchar* gpg_strerror (gpg_err_code_t code);
GType deja_dup_tool_job_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupToolJob, g_object_unref)
GType duplicity_job_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DuplicityJob, g_object_unref)
GType deja_dup_tool_job_mode_get_type (void) G_GNUC_CONST;
GType duplicity_job_state_get_type (void) G_GNUC_CONST;
GType duplicity_instance_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DuplicityInstance, g_object_unref)
static GType duplicity_job_date_info_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static DuplicityJobDateInfo* duplicity_job_date_info_dup (const DuplicityJobDateInfo* self);
static void duplicity_job_date_info_free (DuplicityJobDateInfo* self);
GType deja_dup_network_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupNetwork, g_object_unref)
DejaDupNetwork* deja_dup_network_get (void);
static void duplicity_job_network_changed (DuplicityJob* self);
static void _duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _duplicity_job_date_info_free0_ (gpointer var);
static inline void _g_list_free__duplicity_job_date_info_free0_ (GList* self);
#define DUPLICITY_JOB_MINIMUM_FULL 2
#define DUPLICITY_JOB_ERROR_GENERIC 1
#define DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED 3
#define DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND 19
#define DUPLICITY_JOB_ERROR_EXCEPTION 30
#define DUPLICITY_JOB_ERROR_GPG 31
#define DUPLICITY_JOB_ERROR_BAD_VOLUME 44
#define DUPLICITY_JOB_ERROR_BACKEND 50
#define DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED 51
#define DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND 52
#define DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE 53
#define DUPLICITY_JOB_INFO_PROGRESS 2
#define DUPLICITY_JOB_INFO_COLLECTION_STATUS 3
#define DUPLICITY_JOB_INFO_DIFF_FILE_NEW 4
#define DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED 5
#define DUPLICITY_JOB_INFO_DIFF_FILE_DELETED 6
#define DUPLICITY_JOB_INFO_PATCH_FILE_WRITING 7
#define DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING 8
#define DUPLICITY_JOB_INFO_FILE_STAT 10
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN 11
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN 12
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_DONE 13
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_DONE 14
#define DUPLICITY_JOB_WARNING_ORPHANED_SIG 2
#define DUPLICITY_JOB_WARNING_UNNECESSARY_SIG 3
#define DUPLICITY_JOB_WARNING_UNMATCHED_SIG 4
#define DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP 5
#define DUPLICITY_JOB_WARNING_ORPHANED_BACKUP 6
#define DUPLICITY_JOB_WARNING_CANNOT_READ 10
#define DUPLICITY_JOB_WARNING_CANNOT_PROCESS 12
#define DUPLICITY_JOB_DEBUG_GENERIC 1
gboolean deja_dup_network_get_connected (DejaDupNetwork* self);
void deja_dup_tool_job_resume (DejaDupToolJob* self);
void deja_dup_tool_job_pause (DejaDupToolJob* self,
                              const gchar* reason);
static void duplicity_job_real_start (DejaDupToolJob* base);
static DejaDupToolJobMode duplicity_job_get_original_mode (DuplicityJob* self);
DejaDupToolJobMode deja_dup_tool_job_get_mode (DejaDupToolJob* self);
static void duplicity_job_set_original_mode (DuplicityJob* self,
                                      DejaDupToolJobMode value);
void deja_dup_tool_job_set_mode (DejaDupToolJob* self,
                                 DejaDupToolJobMode value);
GType deja_dup_backend_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupBackend, g_object_unref)
DejaDupBackend* deja_dup_tool_job_get_backend (DejaDupToolJob* self);
void deja_dup_backend_add_argv (DejaDupBackend* self,
                                DejaDupToolJobMode mode,
                                GList* * argv);
static void duplicity_job_process_include_excludes (DuplicityJob* self);
GType deja_dup_filtered_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupFilteredSettings, g_object_unref)
DejaDupFilteredSettings* deja_dup_get_settings (const gchar* subdir);
#define DEJA_DUP_DELETE_AFTER_KEY "delete-after"
static void duplicity_job_async_setup (DuplicityJob* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static void duplicity_job_async_setup_finish (DuplicityJob* self,
                                       GAsyncResult* _res_);
static void duplicity_job_async_setup_data_free (gpointer _data);
static gboolean duplicity_job_async_setup_co (DuplicityJobAsyncSetupData* _data_);
GType deja_dup_tool_job_flags_get_type (void) G_GNUC_CONST;
DejaDupToolJobFlags deja_dup_tool_job_get_flags (DejaDupToolJob* self);
void deja_dup_get_tempdir (GAsyncReadyCallback _callback_,
                           gpointer _user_data_);
gchar* deja_dup_get_tempdir_finish (GAsyncResult* _res_);
static void duplicity_job_async_setup_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void duplicity_job_continue_with_envp (DuplicityJob* self,
                                       DejaDupBackend* b,
                                       gboolean success,
                                       GList* envp,
                                       const gchar* _error_);
static void _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready (DejaDupBackend* _sender,
                                                                    gboolean success,
                                                                    GList* envp,
                                                                    const gchar* _error_,
                                                                    gpointer self);
void deja_dup_backend_get_envp (DejaDupBackend* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
void deja_dup_backend_get_envp_finish (DejaDupBackend* self,
                                       GAsyncResult* _res_,
                                       GError** error);
static gboolean duplicity_job_restart (DuplicityJob* self);
gboolean deja_dup_backend_is_native (DejaDupBackend* self);
static gint duplicity_job_cmp_prefix (DuplicityJob* self,
                               GFile* a,
                               GFile* b);
static gchar* duplicity_job_get_remote (DuplicityJob* self,
                                 DejaDupBackend* backend_override);
gchar* deja_dup_backend_get_location (DejaDupBackend* self,
                                      gboolean* as_root);
static void duplicity_job_expand_links_in_file (DuplicityJob* self,
                                         GFile* file,
                                         GList* * all,
                                         gboolean include,
                                         GList* seen);
static gint ______lambda9_ (GFile* a,
                     GFile* b);
static gint _______lambda9__gcompare_func (gconstpointer a,
                                    gconstpointer b);
static void duplicity_job_expand_links_in_list (DuplicityJob* self,
                                         GList* * all,
                                         gboolean include);
static gchar* duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                            const gchar* path);
static void duplicity_job_real_cancel (DejaDupToolJob* base);
DuplicityJobState duplicity_job_get_state (DuplicityJob* self);
static gboolean duplicity_job_cleanup (DuplicityJob* self);
static void duplicity_job_cancel_inst (DuplicityJob* self);
static void duplicity_job_real_stop (DejaDupToolJob* base);
static void duplicity_job_set_was_stopped (DuplicityJob* self,
                                    gboolean value);
static void duplicity_job_real_pause (DejaDupToolJob* base,
                               const gchar* reason);
void duplicity_instance_pause (DuplicityInstance* self);
static void duplicity_job_set_status (DuplicityJob* self,
                               const gchar* msg,
                               gboolean save);
static void duplicity_job_real_resume (DejaDupToolJob* base);
void duplicity_instance_resume (DuplicityInstance* self);
static void duplicity_job_set_saved_status (DuplicityJob* self);
static void duplicity_job_disconnect_inst (DuplicityJob* self);
static void duplicity_job_handle_done (DuplicityJob* self,
                                DuplicityInstance* inst,
                                gboolean success,
                                gboolean cancelled);
void duplicity_job_set_state (DuplicityJob* self,
                              DuplicityJobState value);
GList* deja_dup_tool_job_get_restore_files (DejaDupToolJob* self);
static void duplicity_job_report_full_backups (DuplicityJob* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void duplicity_job_report_full_backups_finish (DuplicityJob* self,
                                               GAsyncResult* _res_);
static void duplicity_job_check_backup_space (DuplicityJob* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                              GAsyncResult* _res_);
static void duplicity_job_delete_cache (DuplicityJob* self);
static GFile* duplicity_job_make_local_rel_path (DuplicityJob* self,
                                          GFile* file);
static void duplicity_job_show_error (DuplicityJob* self,
                               const gchar* errorstr,
                               const gchar* detail);
gboolean deja_dup_in_testing_mode (void);
GFile* deja_dup_tool_job_get_local (DejaDupToolJob* self);
gchar* deja_dup_operation_mode_to_string (DejaDupToolJobMode mode);
static void duplicity_job_connect_and_start (DuplicityJob* self,
                                      GList* argv_extra,
                                      GList* envp_extra,
                                      GList* argv_entire,
                                      GFile* custom_local);
static void duplicity_job_report_full_backups_data_free (gpointer _data);
static gboolean duplicity_job_report_full_backups_co (DuplicityJobReportFullBackupsData* _data_);
void deja_dup_backend_report_full_backups (DejaDupBackend* self,
                                           gboolean first_backup,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
DejaDupBackend* deja_dup_backend_report_full_backups_finish (DejaDupBackend* self,
                                                             GAsyncResult* _res_);
static void duplicity_job_report_full_backups_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void duplicity_job_delete_excess (DuplicityJob* self,
                                  gint cutoff,
                                  DejaDupBackend* backend_override);
void deja_dup_get_full_backup_threshold_date (GDate* result);
static void duplicity_job_check_backup_space_data_free (gpointer _data);
static gboolean duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_);
void deja_dup_backend_get_space (DejaDupBackend* self,
                                 gboolean free,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
guint64 deja_dup_backend_get_space_finish (DejaDupBackend* self,
                                           GAsyncResult* _res_);
static void duplicity_job_check_backup_space_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static gboolean duplicity_job_can_ignore_error (DuplicityJob* self);
static gboolean duplicity_job_delete_files_if_needed (DuplicityJob* self);
static gboolean duplicity_job_get_was_stopped (DuplicityJob* self);
static gboolean duplicity_job_get_error_issued (DuplicityJob* self);
static void duplicity_job_set_status_file (DuplicityJob* self,
                                    GFile* file,
                                    gboolean action,
                                    gboolean save);
GType deja_dup_recursive_op_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupRecursiveOp, g_object_unref)
GType deja_dup_recursive_delete_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupRecursiveDelete, g_object_unref)
DejaDupRecursiveDelete* deja_dup_recursive_delete_new (GFile* source,
                                                       const gchar* skip);
DejaDupRecursiveDelete* deja_dup_recursive_delete_construct (GType object_type,
                                                             GFile* source,
                                                             const gchar* skip);
void deja_dup_recursive_op_start (DejaDupRecursiveOp* self);
static gboolean duplicity_job_restart_without_cache (DuplicityJob* self);
static void duplicity_job_handle_exit (DuplicityJob* self,
                                gint code);
static void duplicity_job_handle_message (DuplicityJob* self,
                                   DuplicityInstance* inst,
                                   gchar** control_line,
                                   gint control_line_length1,
                                   GList* data_lines,
                                   const gchar* user_text);
void duplicity_job_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  gint firstline_length1,
                                  GList* data,
                                  const gchar* text_in);
void duplicity_job_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 gint firstline_length1,
                                 GList* data,
                                 const gchar* text);
void duplicity_job_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    gint firstline_length1,
                                    GList* data,
                                    const gchar* text);
static gboolean duplicity_job_ask_question (DuplicityJob* self,
                                     const gchar* t,
                                     const gchar* m);
static gchar* duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                           const gchar* file,
                                           gint skip_bits);
static void duplicity_job_report_encryption_error (DuplicityJob* self);
static gboolean duplicity_job_check_encryption_error (DuplicityJob* self,
                                               const gchar* text);
static void duplicity_job_real_process_error (DuplicityJob* self,
                                       gchar** firstline,
                                       gint firstline_length1,
                                       GList* data,
                                       const gchar* text_in);
static void duplicity_job_process_exception (DuplicityJob* self,
                                      const gchar* exception,
                                      const gchar* text);
static GFile* duplicity_job_make_file_obj (DuplicityJob* self,
                                    const gchar* file);
GType deja_dup_backend_s3_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DejaDupBackendS3, g_object_unref)
gboolean deja_dup_backend_s3_bump_bucket (DejaDupBackendS3* self);
gchar* deja_dup_backend_get_location_pretty (DejaDupBackend* self);
static void duplicity_job_real_process_info (DuplicityJob* self,
                                      gchar** firstline,
                                      gint firstline_length1,
                                      GList* data,
                                      const gchar* text);
static void duplicity_job_process_diff_file (DuplicityJob* self,
                                      const gchar* file);
static void duplicity_job_process_patch_file (DuplicityJob* self,
                                       const gchar* file);
static void duplicity_job_process_progress (DuplicityJob* self,
                                     gchar** firstline,
                                     gint firstline_length1);
static void duplicity_job_process_collection_status (DuplicityJob* self,
                                              GList* lines);
static void duplicity_job_process_file_stat (DuplicityJob* self,
                                      const gchar* date,
                                      const gchar* file,
                                      GList* data,
                                      const gchar* text);
static void duplicity_job_real_process_warning (DuplicityJob* self,
                                         gchar** firstline,
                                         gint firstline_length1,
                                         GList* data,
                                         const gchar* text);
static void duplicity_job_set_error_issued (DuplicityJob* self,
                                     gboolean value);
static gint duplicity_job_get_volsize (DuplicityJob* self);
static void _duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                         gboolean success,
                                                         gboolean cancelled,
                                                         gpointer self);
static void _duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                               gchar** control_line,
                                                               gint control_line_length1,
                                                               GList* data_lines,
                                                               const gchar* user_text,
                                                               gpointer self);
static void _duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                           gint code,
                                                           gpointer self);
void duplicity_instance_cancel (DuplicityInstance* self);
DuplicityInstance* duplicity_instance_new (void);
DuplicityInstance* duplicity_instance_construct (GType object_type);
void duplicity_instance_set_forced_cache_dir (DuplicityInstance* self,
                                              const gchar* value);
const gchar* deja_dup_tool_job_get_time (DejaDupToolJob* self);
const gchar* deja_dup_tool_job_get_encrypt_password (DejaDupToolJob* self);
void duplicity_instance_start (DuplicityInstance* self,
                               GList* argv_in,
                               GList* envp_in,
                               gboolean as_root,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
void duplicity_instance_start_finish (DuplicityInstance* self,
                                      GAsyncResult* _res_);
DuplicityJob* duplicity_job_new (void);
DuplicityJob* duplicity_job_construct (GType object_type);
DejaDupToolJob* deja_dup_tool_job_construct (GType object_type);
static GObject * duplicity_job_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void duplicity_job_finalize (GObject * obj);
static void _vala_duplicity_job_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_duplicity_job_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
duplicity_job_get_instance_private (DuplicityJob* self)
{
	return G_STRUCT_MEMBER_P (self, DuplicityJob_private_offset);
}

static void
_duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_network_changed ((DuplicityJob*) self);
#line 711 "DuplicityJob.c"
}

GType
duplicity_job_state_get_type (void)
{
	static volatile gsize duplicity_job_state_type_id__volatile = 0;
	if (g_once_init_enter (&duplicity_job_state_type_id__volatile)) {
		static const GEnumValue values[] = {{DUPLICITY_JOB_STATE_NOT_STARTED, "DUPLICITY_JOB_STATE_NOT_STARTED", "not-started"}, {DUPLICITY_JOB_STATE_NORMAL, "DUPLICITY_JOB_STATE_NORMAL", "normal"}, {DUPLICITY_JOB_STATE_DRY_RUN, "DUPLICITY_JOB_STATE_DRY_RUN", "dry-run"}, {DUPLICITY_JOB_STATE_STATUS, "DUPLICITY_JOB_STATE_STATUS", "status"}, {DUPLICITY_JOB_STATE_CHECK_CONTENTS, "DUPLICITY_JOB_STATE_CHECK_CONTENTS", "check-contents"}, {DUPLICITY_JOB_STATE_CLEANUP, "DUPLICITY_JOB_STATE_CLEANUP", "cleanup"}, {DUPLICITY_JOB_STATE_DELETE, "DUPLICITY_JOB_STATE_DELETE", "delete"}, {0, NULL, NULL}};
		GType duplicity_job_state_type_id;
		duplicity_job_state_type_id = g_enum_register_static ("DuplicityJobState", values);
		g_once_init_leave (&duplicity_job_state_type_id__volatile, duplicity_job_state_type_id);
	}
	return duplicity_job_state_type_id__volatile;
}

static void
_g_free0_ (gpointer var)
{
#line 50 "../libdeja/tools/duplicity/DuplicityJob.vala"
	var = (g_free (var), NULL);
#line 732 "DuplicityJob.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 50 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 740 "DuplicityJob.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 73 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 748 "DuplicityJob.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 73 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 756 "DuplicityJob.c"
}

static void
_duplicity_job_date_info_free0_ (gpointer var)
{
#line 83 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(var == NULL) ? NULL : (var = (duplicity_job_date_info_free (var), NULL));
#line 764 "DuplicityJob.c"
}

static inline void
_g_list_free__duplicity_job_date_info_free0_ (GList* self)
{
#line 83 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_list_free_full (self, (GDestroyNotify) _duplicity_job_date_info_free0_);
#line 772 "DuplicityJob.c"
}

static void
duplicity_job_network_changed (DuplicityJob* self)
{
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 96 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_network_get ();
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = deja_dup_network_get_connected (_tmp1_);
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = _tmp3_;
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp1_);
#line 98 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp4_) {
#line 99 "../libdeja/tools/duplicity/DuplicityJob.vala"
		deja_dup_tool_job_resume ((DejaDupToolJob*) self);
#line 801 "DuplicityJob.c"
	} else {
#line 101 "../libdeja/tools/duplicity/DuplicityJob.vala"
		deja_dup_tool_job_pause ((DejaDupToolJob*) self, _ ("Paused (no network)"));
#line 805 "DuplicityJob.c"
	}
}

static void
duplicity_job_real_start (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp3_;
	DejaDupBackend* _tmp4_;
	DejaDupBackend* _tmp5_;
	DejaDupBackend* _tmp6_;
	DejaDupBackend* _tmp7_;
	DejaDupToolJobMode _tmp8_;
	DejaDupToolJobMode _tmp9_;
	DejaDupToolJobMode _tmp10_;
	DejaDupToolJobMode _tmp11_;
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp12_;
#line 117 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 120 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_original_mode;
#line 120 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 831 "DuplicityJob.c"
		DejaDupToolJobMode _tmp1_;
		DejaDupToolJobMode _tmp2_;
#line 121 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 121 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = _tmp1_;
#line 121 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_original_mode (self, _tmp2_);
#line 840 "DuplicityJob.c"
	}
#line 122 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = self->priv->_original_mode;
#line 122 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp3_);
#line 123 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->saved_argv == NULL) ? NULL : (self->priv->saved_argv = (_g_list_free__g_free0_ (self->priv->saved_argv), NULL));
#line 123 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->saved_argv = NULL;
#line 124 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->saved_envp == NULL) ? NULL : (self->priv->saved_envp = (_g_list_free__g_free0_ (self->priv->saved_envp), NULL));
#line 124 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->saved_envp = NULL;
#line 125 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->backend_argv == NULL) ? NULL : (self->priv->backend_argv = (_g_list_free__g_free0_ (self->priv->backend_argv), NULL));
#line 125 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->backend_argv = NULL;
#line 126 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 126 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = _tmp4_;
#line 126 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_backend_add_argv (_tmp5_, DEJA_DUP_TOOL_JOB_MODE_INVALID, &self->priv->backend_argv);
#line 127 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp6_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 127 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp7_ = _tmp6_;
#line 127 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp8_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 127 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp9_ = _tmp8_;
#line 127 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_backend_add_argv (_tmp7_, _tmp9_, &self->priv->saved_argv);
#line 129 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp10_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 129 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp11_ = _tmp10_;
#line 129 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp11_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 130 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_process_include_excludes (self);
#line 882 "DuplicityJob.c"
	}
#line 132 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp12_ = deja_dup_get_settings (NULL);
#line 132 "../libdeja/tools/duplicity/DuplicityJob.vala"
	settings = _tmp12_;
#line 133 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->delete_age = g_settings_get_int ((GSettings*) settings, DEJA_DUP_DELETE_AFTER_KEY);
#line 135 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_async_setup (self, NULL, NULL);
#line 117 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (settings);
#line 894 "DuplicityJob.c"
}

static void
duplicity_job_async_setup_data_free (gpointer _data)
{
	DuplicityJobAsyncSetupData* _data_;
	_data_ = _data;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobAsyncSetupData, _data_);
#line 906 "DuplicityJob.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return self ? g_object_ref (self) : NULL;
#line 914 "DuplicityJob.c"
}

static void
duplicity_job_async_setup (DuplicityJob* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	DuplicityJobAsyncSetupData* _data_;
	DuplicityJob* _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobAsyncSetupData);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_async_setup_data_free);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_async_setup_co (_data_);
#line 936 "DuplicityJob.c"
}

static void
duplicity_job_async_setup_finish (DuplicityJob* self,
                                  GAsyncResult* _res_)
{
	DuplicityJobAsyncSetupData* _data_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 946 "DuplicityJob.c"
}

static void
duplicity_job_async_setup_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	DuplicityJobAsyncSetupData* _data_;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = _user_data_;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_source_object_ = source_object;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_res_ = _res_;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_async_setup_co (_data_);
#line 963 "DuplicityJob.c"
}

static void
_duplicity_job_continue_with_envp_deja_dup_backend_envp_ready (DejaDupBackend* _sender,
                                                               gboolean success,
                                                               GList* envp,
                                                               const gchar* _error_,
                                                               gpointer self)
{
#line 149 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_continue_with_envp ((DuplicityJob*) self, _sender, success, envp, _error_);
#line 975 "DuplicityJob.c"
}

static gboolean
duplicity_job_async_setup_co (DuplicityJobAsyncSetupData* _data_)
{
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 0:
#line 985 "DuplicityJob.c"
		goto _state_0;
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 1:
#line 989 "DuplicityJob.c"
		goto _state_1;
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 2:
#line 993 "DuplicityJob.c"
		goto _state_2;
		default:
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 998 "DuplicityJob.c"
	}
	_state_0:
#line 141 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) _data_->self);
#line 141 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 141 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if ((_data_->_tmp1_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_CACHE) != 0) {
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_state_ = 1;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		deja_dup_get_tempdir (duplicity_job_async_setup_ready, _data_);
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return FALSE;
#line 1013 "DuplicityJob.c"
		_state_1:
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp2_ = deja_dup_get_tempdir_finish (_data_->_res_);
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp4_ = g_build_filename (_data_->_tmp3_, "duplicity-XXXXXX", NULL);
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->_tmp3_);
#line 143 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->template = _data_->_tmp5_;
#line 144 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp6_ = _data_->template;
#line 144 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 144 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp8_ = mkdtemp (_data_->_tmp7_);
#line 144 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->self->priv->forced_cache_dir);
#line 144 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->self->priv->forced_cache_dir = _data_->_tmp8_;
#line 141 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->template);
#line 1039 "DuplicityJob.c"
	}
	{
#line 149 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 149 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 149 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_connect_object (_data_->_tmp10_, "envp-ready", (GCallback) _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready, _data_->self, 0);
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp11_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_state_ = 2;
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		deja_dup_backend_get_envp (_data_->_tmp12_, duplicity_job_async_setup_ready, _data_);
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return FALSE;
#line 1058 "DuplicityJob.c"
		_state_2:
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		deja_dup_backend_get_envp_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
#line 150 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1064 "DuplicityJob.c"
			goto __catch70_g_error;
		}
	}
	goto __finally70;
	__catch70_g_error:
	{
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->e = _data_->_inner_error0_;
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_inner_error0_ = NULL;
#line 153 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp13_ = _data_->e;
#line 153 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp14_ = _data_->_tmp13_->message;
#line 153 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "raise-error", _data_->_tmp14_, NULL);
#line 154 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_error_free0 (_data_->e);
#line 1085 "DuplicityJob.c"
	}
	__finally70:
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 148 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return FALSE;
#line 1098 "DuplicityJob.c"
	}
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1108 "DuplicityJob.c"
		}
	}
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 138 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 1115 "DuplicityJob.c"
}

static void
duplicity_job_continue_with_envp (DuplicityJob* self,
                                  DejaDupBackend* b,
                                  gboolean success,
                                  GList* envp,
                                  const gchar* _error_)
{
	DejaDupBackend* _tmp0_;
	DejaDupBackend* _tmp1_;
	guint _tmp2_;
	DejaDupBackend* _tmp6_;
	DejaDupBackend* _tmp7_;
#line 158 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 158 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (b != NULL);
#line 165 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 165 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 165 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_parse_name ("envp-ready", DEJA_DUP_TYPE_BACKEND, &_tmp2_, NULL, FALSE);
#line 165 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready, self);
#line 167 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!success) {
#line 168 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_error_ != NULL) {
#line 169 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_signal_emit_by_name ((DejaDupToolJob*) self, "raise-error", _error_, NULL);
#line 1148 "DuplicityJob.c"
		}
#line 170 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) self, "done", FALSE, FALSE, NULL);
#line 171 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 1154 "DuplicityJob.c"
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 174 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = envp;
#line 174 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 1163 "DuplicityJob.c"
			gchar* _tmp3_;
			gchar* s = NULL;
#line 174 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp3_ = g_strdup ((const gchar*) s_it->data);
#line 174 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp3_;
#line 1170 "DuplicityJob.c"
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 175 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp4_ = s;
#line 175 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp5_ = g_strdup (_tmp4_);
#line 175 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->saved_envp = g_list_append (self->priv->saved_envp, _tmp5_);
#line 174 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 1182 "DuplicityJob.c"
			}
		}
	}
#line 177 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!duplicity_job_restart (self)) {
#line 178 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) self, "done", FALSE, FALSE, NULL);
#line 1190 "DuplicityJob.c"
	}
#line 180 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp6_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 180 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp7_ = _tmp6_;
#line 180 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!deja_dup_backend_is_native (_tmp7_)) {
#line 1198 "DuplicityJob.c"
		DejaDupNetwork* _tmp8_;
		DejaDupNetwork* _tmp9_;
		DejaDupNetwork* _tmp10_;
		DejaDupNetwork* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 181 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp8_ = deja_dup_network_get ();
#line 181 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp9_ = _tmp8_;
#line 181 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_connect_object ((GObject*) _tmp9_, "notify::connected", (GCallback) _duplicity_job_network_changed_g_object_notify, self, 0);
#line 181 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_tmp9_);
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp10_ = deja_dup_network_get ();
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp11_ = _tmp10_;
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp12_ = deja_dup_network_get_connected (_tmp11_);
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp13_ = _tmp12_;
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp14_ = !_tmp13_;
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_tmp11_);
#line 182 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp14_) {
#line 183 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_debug ("DuplicityJob.vala:183: No connection found. Postponing the backup.");
#line 184 "../libdeja/tools/duplicity/DuplicityJob.vala"
			deja_dup_tool_job_pause ((DejaDupToolJob*) self, _ ("Paused (no network)"));
#line 1232 "DuplicityJob.c"
		}
	}
}

static gint
duplicity_job_cmp_prefix (DuplicityJob* self,
                          GFile* a,
                          GFile* b)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
#line 190 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 192 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (a == NULL) {
#line 192 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = b == NULL;
#line 1250 "DuplicityJob.c"
	} else {
#line 192 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 1254 "DuplicityJob.c"
	}
#line 192 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 193 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = 0;
#line 193 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 1262 "DuplicityJob.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 194 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (b == NULL) {
#line 194 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp1_ = TRUE;
#line 1269 "DuplicityJob.c"
		} else {
#line 194 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp1_ = g_file_has_prefix (a, b);
#line 1273 "DuplicityJob.c"
		}
#line 194 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp1_) {
#line 195 "../libdeja/tools/duplicity/DuplicityJob.vala"
			result = -1;
#line 195 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return result;
#line 1281 "DuplicityJob.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 196 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (a == NULL) {
#line 196 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp2_ = TRUE;
#line 1288 "DuplicityJob.c"
			} else {
#line 196 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp2_ = g_file_has_prefix (b, a);
#line 1292 "DuplicityJob.c"
			}
#line 196 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (_tmp2_) {
#line 197 "../libdeja/tools/duplicity/DuplicityJob.vala"
				result = 1;
#line 197 "../libdeja/tools/duplicity/DuplicityJob.vala"
				return result;
#line 1300 "DuplicityJob.c"
			} else {
#line 199 "../libdeja/tools/duplicity/DuplicityJob.vala"
				result = 0;
#line 199 "../libdeja/tools/duplicity/DuplicityJob.vala"
				return result;
#line 1306 "DuplicityJob.c"
			}
		}
	}
}

static gchar*
duplicity_job_get_remote (DuplicityJob* self,
                          DejaDupBackend* backend_override)
{
	gchar* result = NULL;
	gchar* _tmp2_;
#line 202 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (backend_override == NULL) {
#line 1322 "DuplicityJob.c"
		DejaDupBackend* _tmp0_;
		DejaDupBackend* _tmp1_;
#line 205 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 205 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = _tmp0_;
#line 205 "../libdeja/tools/duplicity/DuplicityJob.vala"
		backend_override = _tmp1_;
#line 1331 "DuplicityJob.c"
	}
#line 206 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = deja_dup_backend_get_location (backend_override, &self->priv->needs_root);
#line 206 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp2_;
#line 206 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 1339 "DuplicityJob.c"
}

static gint
______lambda9_ (GFile* a,
                GFile* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (a != NULL) {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = b != NULL;
#line 1358 "DuplicityJob.c"
	} else {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = FALSE;
#line 1362 "DuplicityJob.c"
	}
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_) {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = g_file_equal (a, b);
#line 1368 "DuplicityJob.c"
	} else {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = FALSE;
#line 1372 "DuplicityJob.c"
	}
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp1_) {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = 0;
#line 1378 "DuplicityJob.c"
	} else {
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = 1;
#line 1382 "DuplicityJob.c"
	}
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp0_;
#line 241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 1388 "DuplicityJob.c"
}

static gint
_______lambda9__gcompare_func (gconstpointer a,
                               gconstpointer b)
{
	gint result;
	result = ______lambda9_ ((GFile*) a, (GFile*) b);
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 1399 "DuplicityJob.c"
}

static void
duplicity_job_expand_links_in_file (DuplicityJob* self,
                                    GFile* file,
                                    GList* * all,
                                    gboolean include,
                                    GList* seen)
{
	GList* pieces = NULL;
	GFile* iter = NULL;
	GFile* _tmp0_;
	GFile* parent = NULL;
	GError* _inner_error0_ = NULL;
#line 209 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 209 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 222 "../libdeja/tools/duplicity/DuplicityJob.vala"
	pieces = NULL;
#line 223 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 223 "../libdeja/tools/duplicity/DuplicityJob.vala"
	iter = _tmp0_;
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
	while (TRUE) {
#line 1426 "DuplicityJob.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = iter;
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = g_file_get_parent (_tmp1_);
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (parent);
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		parent = _tmp2_;
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = parent;
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (!(_tmp3_ != NULL)) {
#line 224 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 1449 "DuplicityJob.c"
		}
#line 225 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = parent;
#line 225 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = iter;
#line 225 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp6_ = g_file_get_relative_path (_tmp4_, _tmp5_);
#line 225 "../libdeja/tools/duplicity/DuplicityJob.vala"
		pieces = g_list_prepend (pieces, _tmp6_);
#line 226 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp7_ = parent;
#line 226 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 226 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (iter);
#line 226 "../libdeja/tools/duplicity/DuplicityJob.vala"
		iter = _tmp8_;
#line 1467 "DuplicityJob.c"
	}
	{
		GFile* so_far = NULL;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GList* _tmp11_;
#line 230 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp9_ = duplicity_job_slash;
#line 230 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 230 "../libdeja/tools/duplicity/DuplicityJob.vala"
		so_far = _tmp10_;
#line 231 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp11_ = pieces;
#line 1482 "DuplicityJob.c"
		{
			GList* piece_collection = NULL;
			GList* piece_it = NULL;
#line 231 "../libdeja/tools/duplicity/DuplicityJob.vala"
			piece_collection = _tmp11_;
#line 231 "../libdeja/tools/duplicity/DuplicityJob.vala"
			for (piece_it = piece_collection; piece_it != NULL; piece_it = piece_it->next) {
#line 1490 "DuplicityJob.c"
				const gchar* piece = NULL;
#line 231 "../libdeja/tools/duplicity/DuplicityJob.vala"
				piece = (const gchar*) piece_it->data;
#line 1494 "DuplicityJob.c"
				{
					GFile* _tmp12_;
					GFile* _tmp13_;
					GFile* _tmp14_;
					const gchar* _tmp15_;
					GFile* _tmp16_;
					GFileInfo* info = NULL;
					GFile* _tmp17_;
					GFileInfo* _tmp18_;
					GFileInfo* _tmp19_;
#line 232 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp12_ = so_far;
#line 232 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 232 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (parent);
#line 232 "../libdeja/tools/duplicity/DuplicityJob.vala"
					parent = _tmp13_;
#line 233 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp14_ = parent;
#line 233 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp15_ = piece;
#line 233 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp16_ = g_file_resolve_relative_path (_tmp14_, _tmp15_);
#line 233 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (so_far);
#line 233 "../libdeja/tools/duplicity/DuplicityJob.vala"
					so_far = _tmp16_;
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp17_ = so_far;
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp18_ = g_file_query_info (_tmp17_, G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK "," G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
					info = _tmp18_;
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (so_far);
#line 234 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 1535 "DuplicityJob.c"
							goto __catch71_g_io_error_not_found;
						}
						goto __catch71_g_error;
					}
#line 238 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp19_ = info;
#line 238 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (g_file_info_get_is_symlink (_tmp19_)) {
#line 1544 "DuplicityJob.c"
						GFile* _tmp20_;
						GList* _tmp21_;
						gchar* symlink_target = NULL;
						GFileInfo* _tmp24_;
						const gchar* _tmp25_;
						gchar* _tmp26_;
						GFile* full_target = NULL;
						const gchar* _tmp27_;
						gchar* remaining = NULL;
						GFile* _tmp33_;
						gchar* _tmp34_;
						const gchar* _tmp35_;
						GFile* _tmp39_;
						GFile* _tmp40_;
						GFile* _tmp41_;
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp20_ = so_far;
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp21_ = g_list_find_custom (seen, _tmp20_, _______lambda9__gcompare_func);
#line 240 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp21_ != NULL) {
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (info);
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (so_far);
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (parent);
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (iter);
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
#line 242 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return;
#line 1578 "DuplicityJob.c"
						}
#line 244 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (include) {
#line 1582 "DuplicityJob.c"
							GFile* _tmp22_;
							GFile* _tmp23_;
#line 245 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp22_ = so_far;
#line 245 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp23_ = _g_object_ref0 (_tmp22_);
#line 245 "../libdeja/tools/duplicity/DuplicityJob.vala"
							*all = g_list_append (*all, _tmp23_);
#line 1591 "DuplicityJob.c"
						}
#line 251 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp24_ = info;
#line 251 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp25_ = g_file_info_get_symlink_target (_tmp24_);
#line 251 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp26_ = g_strdup (_tmp25_);
#line 251 "../libdeja/tools/duplicity/DuplicityJob.vala"
						symlink_target = _tmp26_;
#line 253 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp27_ = symlink_target;
#line 253 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (g_path_is_absolute (_tmp27_)) {
#line 1605 "DuplicityJob.c"
							const gchar* _tmp28_;
							GFile* _tmp29_;
#line 254 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp28_ = symlink_target;
#line 254 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp29_ = g_file_new_for_path (_tmp28_);
#line 254 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (full_target);
#line 254 "../libdeja/tools/duplicity/DuplicityJob.vala"
							full_target = _tmp29_;
#line 1616 "DuplicityJob.c"
						} else {
							GFile* _tmp30_;
							const gchar* _tmp31_;
							GFile* _tmp32_;
#line 256 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp30_ = parent;
#line 256 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp31_ = symlink_target;
#line 256 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp32_ = g_file_resolve_relative_path (_tmp30_, _tmp31_);
#line 256 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (full_target);
#line 256 "../libdeja/tools/duplicity/DuplicityJob.vala"
							full_target = _tmp32_;
#line 1631 "DuplicityJob.c"
						}
#line 259 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp33_ = so_far;
#line 259 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp34_ = g_file_get_relative_path (_tmp33_, file);
#line 259 "../libdeja/tools/duplicity/DuplicityJob.vala"
						remaining = _tmp34_;
#line 260 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp35_ = remaining;
#line 260 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp35_ != NULL) {
#line 1643 "DuplicityJob.c"
							GFile* _tmp36_;
							const gchar* _tmp37_;
							GFile* _tmp38_;
#line 261 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp36_ = full_target;
#line 261 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp37_ = remaining;
#line 261 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp38_ = g_file_resolve_relative_path (_tmp36_, _tmp37_);
#line 261 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (full_target);
#line 261 "../libdeja/tools/duplicity/DuplicityJob.vala"
							full_target = _tmp38_;
#line 1657 "DuplicityJob.c"
						}
#line 263 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (include) {
#line 264 "../libdeja/tools/duplicity/DuplicityJob.vala"
							*all = g_list_remove (*all, file);
#line 1663 "DuplicityJob.c"
						}
#line 266 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp39_ = so_far;
#line 266 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp40_ = _g_object_ref0 (_tmp39_);
#line 266 "../libdeja/tools/duplicity/DuplicityJob.vala"
						seen = g_list_prepend (seen, _tmp40_);
#line 268 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp41_ = full_target;
#line 268 "../libdeja/tools/duplicity/DuplicityJob.vala"
						duplicity_job_expand_links_in_file (self, _tmp41_, all, include, seen);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (remaining);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (full_target);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (symlink_target);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (info);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (so_far);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (parent);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (iter);
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
#line 269 "../libdeja/tools/duplicity/DuplicityJob.vala"
						return;
#line 1693 "DuplicityJob.c"
					}
#line 231 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (info);
#line 1697 "DuplicityJob.c"
				}
			}
		}
#line 275 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (seen != NULL) {
#line 1703 "DuplicityJob.c"
			GFile* _tmp42_;
#line 276 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp42_ = _g_object_ref0 (file);
#line 276 "../libdeja/tools/duplicity/DuplicityJob.vala"
			*all = g_list_append (*all, _tmp42_);
#line 1709 "DuplicityJob.c"
		}
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (so_far);
#line 1713 "DuplicityJob.c"
	}
	goto __finally71;
	__catch71_g_io_error_not_found:
	{
		GError* e = NULL;
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		e = _inner_error0_;
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_inner_error0_ = NULL;
#line 280 "../libdeja/tools/duplicity/DuplicityJob.vala"
		*all = g_list_remove (*all, file);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_error_free0 (e);
#line 1727 "DuplicityJob.c"
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError* e = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		e = _inner_error0_;
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_inner_error0_ = NULL;
#line 283 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp43_ = e;
#line 283 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp44_ = _tmp43_->message;
#line 283 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_warning ("DuplicityJob.vala:283: %s\n", _tmp44_);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_error_free0 (e);
#line 1747 "DuplicityJob.c"
	}
	__finally71:
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (parent);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (iter);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_clear_error (&_inner_error0_);
#line 229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 1764 "DuplicityJob.c"
	}
#line 209 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (parent);
#line 209 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (iter);
#line 209 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
#line 1772 "DuplicityJob.c"
}

static void
duplicity_job_expand_links_in_list (DuplicityJob* self,
                                    GList* * all,
                                    gboolean include)
{
	GList* all2 = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 287 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 289 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = g_list_copy (*all);
#line 289 "../libdeja/tools/duplicity/DuplicityJob.vala"
	all2 = _tmp0_;
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = all2;
#line 1791 "DuplicityJob.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
		file_collection = _tmp1_;
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1799 "DuplicityJob.c"
			GFile* _tmp2_;
			GFile* file = NULL;
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp2_ = _g_object_ref0 ((GFile*) file_it->data);
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
			file = _tmp2_;
#line 1806 "DuplicityJob.c"
			{
				GFile* _tmp3_;
#line 291 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = file;
#line 291 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_expand_links_in_file (self, _tmp3_, all, include, NULL);
#line 290 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_object_unref0 (file);
#line 1815 "DuplicityJob.c"
			}
		}
	}
#line 287 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(all2 == NULL) ? NULL : (all2 = (g_list_free (all2), NULL));
#line 1821 "DuplicityJob.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1843 "DuplicityJob.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1847 "DuplicityJob.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1853 "DuplicityJob.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1857 "DuplicityJob.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1861 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 1869 "DuplicityJob.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1897 "DuplicityJob.c"
				goto __catch72_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 1906 "DuplicityJob.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1920 "DuplicityJob.c"
				goto __catch72_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 1931 "DuplicityJob.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 1945 "DuplicityJob.c"
	}
	goto __finally72;
	__catch72_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1959 "DuplicityJob.c"
	}
	__finally72:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 1970 "DuplicityJob.c"
	}
}

static gchar*
duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                     const gchar* path)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 294 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 294 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 301 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = string_replace (path, "[", "[[]");
#line 301 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 301 "../libdeja/tools/duplicity/DuplicityJob.vala"
	rv = _tmp0_;
#line 302 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = rv;
#line 302 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = string_replace (_tmp1_, "?", "[?]");
#line 302 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 302 "../libdeja/tools/duplicity/DuplicityJob.vala"
	rv = _tmp2_;
#line 303 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = rv;
#line 303 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = string_replace (_tmp3_, "*", "[*]");
#line 303 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 303 "../libdeja/tools/duplicity/DuplicityJob.vala"
	rv = _tmp4_;
#line 304 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = rv;
#line 304 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 2015 "DuplicityJob.c"
}

static void
duplicity_job_process_include_excludes (DuplicityJob* self)
{
	GList* _tmp0_;
	GList* _tmp21_;
	GList* _tmp29_;
	gchar* _tmp33_;
#line 307 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 309 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_expand_links_in_list (self, &((DejaDupToolJob*) self)->includes, TRUE);
#line 310 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_expand_links_in_list (self, &((DejaDupToolJob*) self)->excludes, FALSE);
#line 315 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJob*) self)->includes = g_list_sort (((DejaDupToolJob*) self)->includes, (GCompareFunc) duplicity_job_cmp_prefix);
#line 316 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJob*) self)->excludes = g_list_sort (((DejaDupToolJob*) self)->excludes, (GCompareFunc) duplicity_job_cmp_prefix);
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = ((DejaDupToolJob*) self)->includes;
#line 2037 "DuplicityJob.c"
	{
		GList* i_collection = NULL;
		GList* i_it = NULL;
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
		i_collection = _tmp0_;
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 2045 "DuplicityJob.c"
			GFile* _tmp1_;
			GFile* i = NULL;
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp1_ = _g_object_ref0 ((GFile*) i_it->data);
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
			i = _tmp1_;
#line 2052 "DuplicityJob.c"
			{
				GList* excludes2 = NULL;
				GList* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				GFile* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 319 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp2_ = ((DejaDupToolJob*) self)->excludes;
#line 319 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = g_list_copy (_tmp2_);
#line 319 "../libdeja/tools/duplicity/DuplicityJob.vala"
				excludes2 = _tmp3_;
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp4_ = excludes2;
#line 2072 "DuplicityJob.c"
				{
					GList* e_collection = NULL;
					GList* e_it = NULL;
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
					e_collection = _tmp4_;
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
					for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 2080 "DuplicityJob.c"
						GFile* _tmp5_;
						GFile* e = NULL;
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp5_ = _g_object_ref0 ((GFile*) e_it->data);
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
						e = _tmp5_;
#line 2087 "DuplicityJob.c"
						{
							GFile* _tmp6_;
							GFile* _tmp7_;
#line 321 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp6_ = e;
#line 321 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp7_ = i;
#line 321 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (g_file_has_prefix (_tmp6_, _tmp7_)) {
#line 2097 "DuplicityJob.c"
								GFile* _tmp8_;
								gchar* _tmp9_;
								gchar* _tmp10_;
								gchar* _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								GFile* _tmp14_;
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp8_ = e;
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp9_ = g_file_get_path (_tmp8_);
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp10_ = _tmp9_;
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp11_ = duplicity_job_escape_duplicity_path (self, _tmp10_);
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp12_ = _tmp11_;
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp13_ = g_strconcat ("--exclude=", _tmp12_, NULL);
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp13_);
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp12_);
#line 322 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp10_);
#line 323 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp14_ = e;
#line 323 "../libdeja/tools/duplicity/DuplicityJob.vala"
								((DejaDupToolJob*) self)->excludes = g_list_remove (((DejaDupToolJob*) self)->excludes, _tmp14_);
#line 2127 "DuplicityJob.c"
							}
#line 320 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (e);
#line 2131 "DuplicityJob.c"
						}
					}
				}
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp15_ = i;
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp16_ = g_file_get_path (_tmp15_);
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp17_ = _tmp16_;
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp18_ = duplicity_job_escape_duplicity_path (self, _tmp17_);
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp19_ = _tmp18_;
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp20_ = g_strconcat ("--include=", _tmp19_, NULL);
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp20_);
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp19_);
#line 326 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp17_);
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
				(excludes2 == NULL) ? NULL : (excludes2 = (g_list_free (excludes2), NULL));
#line 318 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_object_unref0 (i);
#line 2157 "DuplicityJob.c"
			}
		}
	}
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp21_ = ((DejaDupToolJob*) self)->excludes;
#line 2163 "DuplicityJob.c"
	{
		GList* e_collection = NULL;
		GList* e_it = NULL;
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
		e_collection = _tmp21_;
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 2171 "DuplicityJob.c"
			GFile* _tmp22_;
			GFile* e = NULL;
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp22_ = _g_object_ref0 ((GFile*) e_it->data);
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
			e = _tmp22_;
#line 2178 "DuplicityJob.c"
			{
				GFile* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp23_ = e;
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp24_ = g_file_get_path (_tmp23_);
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp25_ = _tmp24_;
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp26_ = duplicity_job_escape_duplicity_path (self, _tmp25_);
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp27_ = _tmp26_;
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp28_ = g_strconcat ("--exclude=", _tmp27_, NULL);
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp28_);
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp27_);
#line 331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp25_);
#line 330 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_object_unref0 (e);
#line 2206 "DuplicityJob.c"
			}
		}
	}
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp29_ = ((DejaDupToolJob*) self)->exclude_regexps;
#line 2212 "DuplicityJob.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
		r_collection = _tmp29_;
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 2220 "DuplicityJob.c"
			gchar* _tmp30_;
			gchar* r = NULL;
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp30_ = g_strdup ((const gchar*) r_it->data);
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
			r = _tmp30_;
#line 2227 "DuplicityJob.c"
			{
				const gchar* _tmp31_;
				gchar* _tmp32_;
#line 337 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp31_ = r;
#line 337 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp32_ = g_strconcat ("--exclude=", _tmp31_, NULL);
#line 337 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp32_);
#line 336 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (r);
#line 2239 "DuplicityJob.c"
			}
		}
	}
#line 340 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp33_ = g_strdup ("--exclude=**");
#line 340 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp33_);
#line 2247 "DuplicityJob.c"
}

static void
duplicity_job_real_cancel (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DejaDupToolJobMode prev_mode = 0;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	gboolean _tmp2_ = FALSE;
	DejaDupToolJobMode _tmp3_;
#line 343 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 344 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 344 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 344 "../libdeja/tools/duplicity/DuplicityJob.vala"
	prev_mode = _tmp1_;
#line 345 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = prev_mode;
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 2273 "DuplicityJob.c"
		DuplicityJobState _tmp4_;
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = self->priv->_state;
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = _tmp4_ == DUPLICITY_JOB_STATE_NORMAL;
#line 2279 "DuplicityJob.c"
	} else {
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = FALSE;
#line 2283 "DuplicityJob.c"
	}
#line 347 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_) {
#line 348 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (duplicity_job_cleanup (self)) {
#line 349 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return;
#line 2291 "DuplicityJob.c"
		}
	}
#line 352 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_cancel_inst (self);
#line 2296 "DuplicityJob.c"
}

static void
duplicity_job_real_stop (DejaDupToolJob* base)
{
	DuplicityJob * self;
#line 355 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 357 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_was_stopped (self, TRUE);
#line 358 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 359 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_cancel_inst (self);
#line 2311 "DuplicityJob.c"
}

static void
duplicity_job_real_pause (DejaDupToolJob* base,
                          const gchar* reason)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
#line 362 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 364 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 364 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 2326 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
#line 365 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 365 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_instance_pause (_tmp1_);
#line 366 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (reason != NULL) {
#line 367 "../libdeja/tools/duplicity/DuplicityJob.vala"
			duplicity_job_set_status (self, reason, FALSE);
#line 2336 "DuplicityJob.c"
		}
	}
}

static void
duplicity_job_real_resume (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
#line 371 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 373 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 373 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 2352 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
#line 374 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 374 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_instance_resume (_tmp1_);
#line 375 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_saved_status (self);
#line 2360 "DuplicityJob.c"
	}
}

static void
duplicity_job_cancel_inst (DuplicityJob* self)
{
#line 379 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 381 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 382 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_handle_done (self, NULL, FALSE, TRUE);
#line 2373 "DuplicityJob.c"
}

static gboolean
duplicity_job_restart (DuplicityJob* self)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	GList* _tmp1_;
	DejaDupToolJobMode _tmp2_;
	DejaDupToolJobMode _tmp3_;
	GList* extra_argv = NULL;
	gchar* action_desc = NULL;
	GFile* custom_local = NULL;
	DejaDupToolJobMode _tmp4_;
	const gchar* _tmp69_;
	const gchar* _tmp73_;
	GList* _tmp74_;
	GFile* _tmp75_;
	GError* _inner_error0_ = NULL;
#line 385 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 387 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_NORMAL);
#line 388 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 388 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 388 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp1_ == NULL) {
#line 389 "../libdeja/tools/duplicity/DuplicityJob.vala"
		(self->priv->local_error_files == NULL) ? NULL : (self->priv->local_error_files = (_g_list_free__g_object_unref0_ (self->priv->local_error_files), NULL));
#line 389 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->local_error_files = NULL;
#line 2407 "DuplicityJob.c"
	}
#line 391 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 391 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 391 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 392 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 392 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 2419 "DuplicityJob.c"
	}
#line 394 "../libdeja/tools/duplicity/DuplicityJob.vala"
	extra_argv = NULL;
#line 395 "../libdeja/tools/duplicity/DuplicityJob.vala"
	action_desc = NULL;
#line 396 "../libdeja/tools/duplicity/DuplicityJob.vala"
	custom_local = NULL;
#line 398 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = self->priv->_original_mode;
#line 398 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (_tmp4_) {
#line 398 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
#line 2433 "DuplicityJob.c"
		{
#line 402 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (!self->priv->checked_collection_info) {
#line 2437 "DuplicityJob.c"
				gchar* _tmp5_;
#line 403 "../libdeja/tools/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
#line 404 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
#line 405 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp5_ = g_strdup (_ ("Preparing…"));
#line 405 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (action_desc);
#line 405 "../libdeja/tools/duplicity/DuplicityJob.vala"
				action_desc = _tmp5_;
#line 2449 "DuplicityJob.c"
			} else {
				gboolean _tmp6_ = FALSE;
#line 407 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (!self->priv->reported_full_backups) {
#line 407 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = self->priv->got_collection_info;
#line 2456 "DuplicityJob.c"
				} else {
#line 407 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = FALSE;
#line 2460 "DuplicityJob.c"
				}
#line 407 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp6_) {
#line 408 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_report_full_backups (self, NULL, NULL);
#line 409 "../libdeja/tools/duplicity/DuplicityJob.vala"
					result = TRUE;
#line 409 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (custom_local);
#line 409 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (action_desc);
#line 409 "../libdeja/tools/duplicity/DuplicityJob.vala"
					(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 409 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return result;
#line 2476 "DuplicityJob.c"
				} else {
					gboolean _tmp7_ = FALSE;
					DejaDupToolJobFlags _tmp8_;
					DejaDupToolJobFlags _tmp9_;
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp8_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) self);
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp9_ = _tmp8_;
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if ((_tmp9_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_PROGRESS) == 0) {
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp7_ = !self->priv->has_progress_total;
#line 2489 "DuplicityJob.c"
					} else {
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp7_ = FALSE;
#line 2493 "DuplicityJob.c"
					}
#line 414 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp7_) {
#line 2497 "DuplicityJob.c"
						gchar* _tmp10_;
						gchar* _tmp11_;
#line 415 "../libdeja/tools/duplicity/DuplicityJob.vala"
						duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DRY_RUN);
#line 416 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp10_ = g_strdup (_ ("Preparing…"));
#line 416 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (action_desc);
#line 416 "../libdeja/tools/duplicity/DuplicityJob.vala"
						action_desc = _tmp10_;
#line 417 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp11_ = g_strdup ("--dry-run");
#line 417 "../libdeja/tools/duplicity/DuplicityJob.vala"
						extra_argv = g_list_append (extra_argv, _tmp11_);
#line 2512 "DuplicityJob.c"
					} else {
#line 419 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (!self->priv->checked_backup_space) {
#line 420 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_check_backup_space (self, NULL, NULL);
#line 421 "../libdeja/tools/duplicity/DuplicityJob.vala"
							result = TRUE;
#line 421 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (custom_local);
#line 421 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (action_desc);
#line 421 "../libdeja/tools/duplicity/DuplicityJob.vala"
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 421 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return result;
#line 2528 "DuplicityJob.c"
						} else {
#line 424 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (self->priv->has_progress_total) {
#line 425 "../libdeja/tools/duplicity/DuplicityJob.vala"
								g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
#line 2534 "DuplicityJob.c"
							}
#line 426 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (self->priv->is_full_backup) {
#line 430 "../libdeja/tools/duplicity/DuplicityJob.vala"
								duplicity_job_delete_cache (self);
#line 2540 "DuplicityJob.c"
							}
						}
					}
				}
			}
#line 434 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 2548 "DuplicityJob.c"
		}
#line 398 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
#line 2552 "DuplicityJob.c"
		{
#line 438 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (!self->priv->checked_collection_info) {
#line 2556 "DuplicityJob.c"
				gchar* _tmp12_;
#line 439 "../libdeja/tools/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
#line 440 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
#line 441 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp12_ = g_strdup (_ ("Preparing…"));
#line 441 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (action_desc);
#line 441 "../libdeja/tools/duplicity/DuplicityJob.vala"
				action_desc = _tmp12_;
#line 2568 "DuplicityJob.c"
			} else {
#line 443 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (!self->priv->has_checked_contents) {
#line 2572 "DuplicityJob.c"
					gchar* _tmp13_;
#line 444 "../libdeja/tools/duplicity/DuplicityJob.vala"
					deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_LIST);
#line 445 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_set_state (self, DUPLICITY_JOB_STATE_CHECK_CONTENTS);
#line 446 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp13_ = g_strdup (_ ("Preparing…"));
#line 446 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (action_desc);
#line 446 "../libdeja/tools/duplicity/DuplicityJob.vala"
					action_desc = _tmp13_;
#line 2584 "DuplicityJob.c"
				} else {
					GList* _tmp14_;
					GList* _tmp30_;
					GList* _tmp31_;
#line 453 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp14_ = self->priv->homes;
#line 453 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (g_list_length (_tmp14_) > ((guint) 1)) {
#line 454 "../libdeja/tools/duplicity/DuplicityJob.vala"
						self->priv->has_non_home_contents = TRUE;
#line 2595 "DuplicityJob.c"
					} else {
						GList* _tmp15_;
#line 455 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp15_ = self->priv->homes;
#line 455 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (g_list_length (_tmp15_) == ((guint) 1)) {
#line 2602 "DuplicityJob.c"
							GFile* old_home = NULL;
							GList* _tmp16_;
							gconstpointer _tmp17_;
							GFile* _tmp18_;
							GFile* new_home = NULL;
							GFile* _tmp19_;
							GFile* _tmp20_;
							GFile* _tmp21_;
							GFile* _tmp22_;
#line 456 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp16_ = self->priv->homes;
#line 456 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp17_ = _tmp16_->data;
#line 456 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp18_ = _g_object_ref0 ((GFile*) _tmp17_);
#line 456 "../libdeja/tools/duplicity/DuplicityJob.vala"
							old_home = _tmp18_;
#line 457 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp19_ = duplicity_job_slash_home_me;
#line 457 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp20_ = _g_object_ref0 (_tmp19_);
#line 457 "../libdeja/tools/duplicity/DuplicityJob.vala"
							new_home = _tmp20_;
#line 458 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp21_ = old_home;
#line 458 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp22_ = new_home;
#line 458 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (!g_file_equal (_tmp21_, _tmp22_)) {
#line 2632 "DuplicityJob.c"
								gchar* _tmp23_;
								GFile* _tmp24_;
								GFile* _tmp25_;
								gchar* _tmp26_;
								GFile* _tmp27_;
								GFile* _tmp28_;
								gchar* _tmp29_;
#line 459 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp23_ = g_strdup ("--rename");
#line 459 "../libdeja/tools/duplicity/DuplicityJob.vala"
								extra_argv = g_list_append (extra_argv, _tmp23_);
#line 460 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp24_ = duplicity_job_slash;
#line 460 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp25_ = old_home;
#line 460 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp26_ = g_file_get_relative_path (_tmp24_, _tmp25_);
#line 460 "../libdeja/tools/duplicity/DuplicityJob.vala"
								extra_argv = g_list_append (extra_argv, _tmp26_);
#line 461 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp27_ = duplicity_job_slash;
#line 461 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp28_ = new_home;
#line 461 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp29_ = g_file_get_relative_path (_tmp27_, _tmp28_);
#line 461 "../libdeja/tools/duplicity/DuplicityJob.vala"
								extra_argv = g_list_append (extra_argv, _tmp29_);
#line 2660 "DuplicityJob.c"
							}
#line 455 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (new_home);
#line 455 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (old_home);
#line 2666 "DuplicityJob.c"
						}
					}
#line 465 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp30_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 465 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp31_ = _tmp30_;
#line 465 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp31_ != NULL) {
#line 2675 "DuplicityJob.c"
						GFile* local_file = NULL;
						GList* _tmp32_;
						GList* _tmp33_;
						gconstpointer _tmp34_;
						GFile* _tmp35_;
						GFile* _tmp36_;
						gboolean _tmp44_ = FALSE;
						GFile* _tmp45_;
						GFile* _tmp46_;
						GFile* _tmp56_;
						GFile* _tmp57_;
						gchar* rel_file_path = NULL;
						GFile* _tmp58_;
						GList* _tmp59_;
						GList* _tmp60_;
						gconstpointer _tmp61_;
						gchar* _tmp62_;
						const gchar* _tmp63_;
						gchar* _tmp64_;
#line 470 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp32_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 470 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp33_ = _tmp32_;
#line 470 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp34_ = _tmp33_->data;
#line 470 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp35_ = duplicity_job_make_local_rel_path (self, (GFile*) _tmp34_);
#line 470 "../libdeja/tools/duplicity/DuplicityJob.vala"
						local_file = _tmp35_;
#line 471 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp36_ = local_file;
#line 471 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp36_ == NULL) {
#line 2709 "DuplicityJob.c"
							GList* _tmp37_;
							GList* _tmp38_;
							gconstpointer _tmp39_;
							gchar* _tmp40_;
							gchar* _tmp41_;
							gchar* _tmp42_;
							gchar* _tmp43_;
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp37_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp38_ = _tmp37_;
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp39_ = _tmp38_->data;
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp40_ = g_file_get_parse_name ((GFile*) _tmp39_);
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp41_ = _tmp40_;
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp42_ = g_strdup_printf (_ ("Could not restore ‘%s’: Not a valid file location"), _tmp41_);
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp43_ = _tmp42_;
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp43_, NULL);
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp43_);
#line 473 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp41_);
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							result = FALSE;
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (local_file);
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (custom_local);
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (action_desc);
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 475 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return result;
#line 2749 "DuplicityJob.c"
						}
#line 478 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp45_ = local_file;
#line 478 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp46_ = duplicity_job_slash_home_me;
#line 478 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (!g_file_has_prefix (_tmp45_, _tmp46_)) {
#line 2757 "DuplicityJob.c"
							gboolean _tmp47_ = FALSE;
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (deja_dup_in_testing_mode ()) {
#line 2761 "DuplicityJob.c"
								GFile* _tmp48_;
								gchar* _tmp49_;
								gchar* _tmp50_;
								const gchar* _tmp51_;
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp48_ = local_file;
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp49_ = g_file_get_path (_tmp48_);
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp50_ = _tmp49_;
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp51_ = g_get_tmp_dir ();
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp47_ = g_str_has_prefix (_tmp50_, _tmp51_);
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp50_);
#line 2778 "DuplicityJob.c"
							} else {
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp47_ = FALSE;
#line 2782 "DuplicityJob.c"
							}
#line 479 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp44_ = !_tmp47_;
#line 2786 "DuplicityJob.c"
						} else {
#line 478 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp44_ = FALSE;
#line 2790 "DuplicityJob.c"
						}
#line 478 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp44_) {
#line 480 "../libdeja/tools/duplicity/DuplicityJob.vala"
							self->priv->needs_root = TRUE;
#line 2796 "DuplicityJob.c"
						}
						{
							GFile* _tmp52_;
#line 484 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp52_ = local_file;
#line 484 "../libdeja/tools/duplicity/DuplicityJob.vala"
							g_file_make_directory_with_parents (_tmp52_, NULL, &_inner_error0_);
#line 484 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 484 "../libdeja/tools/duplicity/DuplicityJob.vala"
								if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 2808 "DuplicityJob.c"
									goto __catch73_g_io_error_exists;
								}
								goto __catch73_g_error;
							}
						}
						goto __finally73;
						__catch73_g_io_error_exists:
						{
							GError* e = NULL;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							e = _inner_error0_;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_inner_error0_ = NULL;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_error_free0 (e);
#line 2824 "DuplicityJob.c"
						}
						goto __finally73;
						__catch73_g_error:
						{
							GError* e = NULL;
							GError* _tmp53_;
							const gchar* _tmp54_;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							e = _inner_error0_;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_inner_error0_ = NULL;
#line 490 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp53_ = e;
#line 490 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp54_ = _tmp53_->message;
#line 490 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp54_, NULL);
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							result = FALSE;
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_error_free0 (e);
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (local_file);
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (custom_local);
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (action_desc);
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 491 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return result;
#line 2856 "DuplicityJob.c"
						}
						__finally73:
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2861 "DuplicityJob.c"
							gboolean _tmp55_ = FALSE;
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (local_file);
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (custom_local);
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (action_desc);
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							g_clear_error (&_inner_error0_);
#line 482 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return _tmp55_;
#line 2877 "DuplicityJob.c"
						}
#line 493 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp56_ = local_file;
#line 493 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp57_ = _g_object_ref0 (_tmp56_);
#line 493 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (custom_local);
#line 493 "../libdeja/tools/duplicity/DuplicityJob.vala"
						custom_local = _tmp57_;
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp58_ = duplicity_job_slash;
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp59_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp60_ = _tmp59_;
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp61_ = _tmp60_->data;
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp62_ = g_file_get_relative_path (_tmp58_, (GFile*) _tmp61_);
#line 495 "../libdeja/tools/duplicity/DuplicityJob.vala"
						rel_file_path = _tmp62_;
#line 496 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp63_ = rel_file_path;
#line 496 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp64_ = g_strdup_printf ("--file-to-restore=%s", _tmp63_);
#line 496 "../libdeja/tools/duplicity/DuplicityJob.vala"
						extra_argv = g_list_append (extra_argv, _tmp64_);
#line 465 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (rel_file_path);
#line 465 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (local_file);
#line 2909 "DuplicityJob.c"
					} else {
						gboolean _tmp65_ = FALSE;
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (self->priv->has_non_home_contents) {
#line 2914 "DuplicityJob.c"
							GFile* _tmp66_;
							GFile* _tmp67_;
							GFile* _tmp68_;
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp66_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp67_ = _tmp66_;
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp68_ = duplicity_job_slash_home_me;
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp65_ = !g_file_has_prefix (_tmp67_, _tmp68_);
#line 2926 "DuplicityJob.c"
						} else {
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp65_ = FALSE;
#line 2930 "DuplicityJob.c"
						}
#line 499 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp65_) {
#line 500 "../libdeja/tools/duplicity/DuplicityJob.vala"
							self->priv->needs_root = TRUE;
#line 2936 "DuplicityJob.c"
						}
					}
#line 503 "../libdeja/tools/duplicity/DuplicityJob.vala"
					g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
#line 2941 "DuplicityJob.c"
				}
			}
#line 505 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 2946 "DuplicityJob.c"
		}
		default:
#line 398 "../libdeja/tools/duplicity/DuplicityJob.vala"
		break;
#line 2951 "DuplicityJob.c"
	}
#line 510 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp69_ = action_desc;
#line 510 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp69_ == NULL) {
#line 2957 "DuplicityJob.c"
		DejaDupToolJobMode _tmp70_;
		DejaDupToolJobMode _tmp71_;
		gchar* _tmp72_;
#line 511 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp70_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 511 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp71_ = _tmp70_;
#line 511 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp72_ = deja_dup_operation_mode_to_string (_tmp71_);
#line 511 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (action_desc);
#line 511 "../libdeja/tools/duplicity/DuplicityJob.vala"
		action_desc = _tmp72_;
#line 2971 "DuplicityJob.c"
	}
#line 512 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp73_ = action_desc;
#line 512 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _tmp73_, TRUE);
#line 514 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp74_ = extra_argv;
#line 514 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp75_ = custom_local;
#line 514 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, _tmp74_, NULL, NULL, _tmp75_);
#line 515 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = TRUE;
#line 515 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (custom_local);
#line 515 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (action_desc);
#line 515 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 515 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 2993 "DuplicityJob.c"
}

static GFile*
duplicity_job_make_local_rel_path (DuplicityJob* self,
                                   GFile* file)
{
	GFile* result = NULL;
	gchar* rel_file_path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	const gchar* _tmp5_;
	GFile* _tmp6_;
#line 518 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 518 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 520 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_slash;
#line 520 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_file_get_relative_path (_tmp0_, file);
#line 520 "../libdeja/tools/duplicity/DuplicityJob.vala"
	rel_file_path = _tmp1_;
#line 521 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = rel_file_path;
#line 521 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ == NULL) {
#line 522 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = NULL;
#line 522 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (rel_file_path);
#line 522 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 3029 "DuplicityJob.c"
	}
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = _tmp3_;
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = rel_file_path;
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp6_ = g_file_resolve_relative_path (_tmp4_, _tmp5_);
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp6_;
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (rel_file_path);
#line 523 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 3045 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups_data_free (gpointer _data)
{
	DuplicityJobReportFullBackupsData* _data_;
	_data_ = _data;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobReportFullBackupsData, _data_);
#line 3057 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups (DuplicityJob* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	DuplicityJobReportFullBackupsData* _data_;
	DuplicityJob* _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobReportFullBackupsData);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_report_full_backups_data_free);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_report_full_backups_co (_data_);
#line 3079 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups_finish (DuplicityJob* self,
                                          GAsyncResult* _res_)
{
	DuplicityJobReportFullBackupsData* _data_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3089 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	DuplicityJobReportFullBackupsData* _data_;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = _user_data_;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_source_object_ = source_object;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_res_ = _res_;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_report_full_backups_co (_data_);
#line 3106 "DuplicityJob.c"
}

static gboolean
duplicity_job_report_full_backups_co (DuplicityJobReportFullBackupsData* _data_)
{
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 0:
#line 3116 "DuplicityJob.c"
		goto _state_0;
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 1:
#line 3120 "DuplicityJob.c"
		goto _state_1;
		default:
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 3125 "DuplicityJob.c"
	}
	_state_0:
#line 528 "../libdeja/tools/duplicity/DuplicityJob.vala"
	memset (&_data_->full_backup, 0, sizeof (GDate));
#line 529 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = _data_->self->priv->collection_info;
#line 3132 "DuplicityJob.c"
	{
#line 529 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->info_collection = _data_->_tmp0_;
#line 529 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 529 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->info = *((DuplicityJobDateInfo*) _data_->info_it->data);
#line 3140 "DuplicityJob.c"
			{
#line 530 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_data_->_tmp1_ = _data_->info;
#line 530 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_data_->_tmp1_.full) {
#line 531 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_data_->_tmp2_ = _data_->info;
#line 531 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_data_->_tmp3_ = _data_->_tmp2_.time;
#line 531 "../libdeja/tools/duplicity/DuplicityJob.vala"
					g_date_set_time_val (&_data_->full_backup, &_data_->_tmp3_);
#line 3152 "DuplicityJob.c"
				}
			}
		}
	}
#line 533 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->first_backup = !g_date_valid (&_data_->full_backup);
#line 535 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->do_restart = TRUE;
#line 536 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->self->priv->reported_full_backups = TRUE;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp4_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_state_ = 1;
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_backend_report_full_backups (_data_->_tmp5_, _data_->first_backup, duplicity_job_report_full_backups_ready, _data_);
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3173 "DuplicityJob.c"
	_state_1:
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp6_ = deja_dup_backend_report_full_backups_finish (_data_->_tmp5_, _data_->_res_);
#line 541 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->delete_backend = _data_->_tmp6_;
#line 542 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp7_ = _data_->delete_backend;
#line 542 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_tmp7_ != NULL) {
#line 543 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp8_ = _data_->delete_backend;
#line 543 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_delete_excess (_data_->self, 1, _data_->_tmp8_);
#line 544 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->first_backup = FALSE;
#line 545 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->do_restart = FALSE;
#line 3191 "DuplicityJob.c"
	}
#line 550 "../libdeja/tools/duplicity/DuplicityJob.vala"
	memset (&_data_->_tmp9_, 0, sizeof (GDate));
#line 550 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_get_full_backup_threshold_date (&_data_->_tmp9_);
#line 550 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->threshold = _data_->_tmp9_;
#line 551 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!g_date_valid (&_data_->full_backup)) {
#line 551 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = TRUE;
#line 3203 "DuplicityJob.c"
	} else {
#line 551 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp11_ = _data_->full_backup;
#line 551 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = g_date_compare (&_data_->threshold, &_data_->_tmp11_) > 0;
#line 3209 "DuplicityJob.c"
	}
#line 551 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_tmp10_) {
#line 552 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->self->priv->is_full_backup = TRUE;
#line 553 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "is-full", _data_->first_backup);
#line 3217 "DuplicityJob.c"
	}
#line 556 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->do_restart) {
#line 556 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp12_ = !duplicity_job_restart (_data_->self);
#line 3223 "DuplicityJob.c"
	} else {
#line 556 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp12_ = FALSE;
#line 3227 "DuplicityJob.c"
	}
#line 556 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_tmp12_) {
#line 557 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 3233 "DuplicityJob.c"
	}
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->delete_backend);
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3245 "DuplicityJob.c"
		}
	}
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 526 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3252 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_data_free (gpointer _data)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	_data_ = _data;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobCheckBackupSpaceData, _data_);
#line 3264 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space (DuplicityJob* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	DuplicityJob* _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobCheckBackupSpaceData);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_check_backup_space_data_free);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_check_backup_space_co (_data_);
#line 3286 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                         GAsyncResult* _res_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3296 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_ = _user_data_;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_source_object_ = source_object;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_res_ = _res_;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_check_backup_space_co (_data_);
#line 3313 "DuplicityJob.c"
}

static gboolean
duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_)
{
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 0:
#line 3323 "DuplicityJob.c"
		goto _state_0;
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 1:
#line 3327 "DuplicityJob.c"
		goto _state_1;
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case 2:
#line 3331 "DuplicityJob.c"
		goto _state_2;
		default:
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 3336 "DuplicityJob.c"
	}
	_state_0:
#line 562 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->self->priv->checked_backup_space = TRUE;
#line 564 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!_data_->self->priv->has_progress_total) {
#line 565 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (!duplicity_job_restart (_data_->self)) {
#line 566 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 3347 "DuplicityJob.c"
		}
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3357 "DuplicityJob.c"
			}
		}
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 567 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return FALSE;
#line 3364 "DuplicityJob.c"
	}
#line 570 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = g_format_size_full (_data_->self->priv->progress_total, G_FORMAT_SIZE_DEFAULT);
#line 570 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->formatted_progress_total = _data_->_tmp0_;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp1_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_state_ = 1;
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_backend_get_space (_data_->_tmp2_, TRUE, duplicity_job_check_backup_space_ready, _data_);
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3380 "DuplicityJob.c"
	_state_1:
#line 571 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->free = deja_dup_backend_get_space_finish (_data_->_tmp2_, _data_->_res_);
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->_state_ = 2;
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_backend_get_space (_data_->_tmp4_, FALSE, duplicity_job_check_backup_space_ready, _data_);
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3394 "DuplicityJob.c"
	_state_2:
#line 572 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_data_->total = deja_dup_backend_get_space_finish (_data_->_tmp4_, _data_->_res_);
#line 575 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->free != deja_dup_backend_INFINITE_SPACE) {
#line 575 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp5_ = _data_->free > _data_->total;
#line 3402 "DuplicityJob.c"
	} else {
#line 575 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp5_ = FALSE;
#line 3406 "DuplicityJob.c"
	}
#line 575 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_tmp5_) {
#line 576 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->total = _data_->free;
#line 3412 "DuplicityJob.c"
	}
#line 577 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->total < _data_->self->priv->progress_total) {
#line 579 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp6_ = g_strdup (_ ("Backup location is too small. Try using one with at least %s."));
#line 579 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->msg = _data_->_tmp6_;
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp7_ = _data_->msg;
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp8_ = _data_->formatted_progress_total;
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = g_strdup_printf (_data_->_tmp7_, _data_->_tmp8_);
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (_data_->self, _data_->_tmp10_, NULL);
#line 580 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->_tmp10_);
#line 581 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->msg);
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->formatted_progress_total);
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3446 "DuplicityJob.c"
			}
		}
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 582 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return FALSE;
#line 3453 "DuplicityJob.c"
	}
#line 585 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->free < _data_->self->priv->progress_total) {
#line 586 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_data_->self->priv->got_collection_info) {
#line 588 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->full_dates = 0;
#line 589 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp11_ = _data_->self->priv->collection_info;
#line 3463 "DuplicityJob.c"
			{
#line 589 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_data_->info_collection = _data_->_tmp11_;
#line 589 "../libdeja/tools/duplicity/DuplicityJob.vala"
				for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 589 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_data_->info = *((DuplicityJobDateInfo*) _data_->info_it->data);
#line 3471 "DuplicityJob.c"
					{
#line 590 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_data_->_tmp12_ = _data_->info;
#line 590 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_data_->_tmp12_.full) {
#line 591 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_data_->full_dates = _data_->full_dates + 1;
#line 3479 "DuplicityJob.c"
						}
					}
				}
			}
#line 594 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (_data_->full_dates > 1) {
#line 595 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_delete_excess (_data_->self, _data_->full_dates - 1, NULL);
#line 597 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_data_->self->priv->checked_backup_space = FALSE;
#line 598 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_data_->self->priv->checked_collection_info = FALSE;
#line 599 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_data_->self->priv->got_collection_info = FALSE;
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (_data_->formatted_progress_total);
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_data_->_state_ != 0) {
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3504 "DuplicityJob.c"
					}
				}
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
				g_object_unref (_data_->_async_result);
#line 600 "../libdeja/tools/duplicity/DuplicityJob.vala"
				return FALSE;
#line 3511 "DuplicityJob.c"
			}
		} else {
#line 604 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp13_ = g_strdup (_ ("Backup location does not have enough free space. Try using one with at" \
" least %s."));
#line 604 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_vala1_msg = _data_->_tmp13_;
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp14_ = _data_->_vala1_msg;
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp15_ = _data_->formatted_progress_total;
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp16_ = g_strdup_printf (_data_->_tmp14_, _data_->_tmp15_);
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			duplicity_job_show_error (_data_->self, _data_->_tmp17_, NULL);
#line 605 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->_tmp17_);
#line 606 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->_vala1_msg);
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->formatted_progress_total);
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (_data_->_state_ != 0) {
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3544 "DuplicityJob.c"
				}
			}
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_object_unref (_data_->_async_result);
#line 607 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return FALSE;
#line 3551 "DuplicityJob.c"
		}
	}
#line 611 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!duplicity_job_restart (_data_->self)) {
#line 612 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
#line 3558 "DuplicityJob.c"
	}
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (_data_->formatted_progress_total);
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3570 "DuplicityJob.c"
		}
	}
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 560 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3577 "DuplicityJob.c"
}

static gboolean
duplicity_job_cleanup (DuplicityJob* self)
{
	gboolean result = FALSE;
	DuplicityJobState _tmp0_;
	GList* cleanup_argv = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GList* _tmp4_;
#line 615 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 616 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_state;
#line 616 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ == DUPLICITY_JOB_STATE_CLEANUP) {
#line 617 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 617 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 3600 "DuplicityJob.c"
	}
#line 619 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_CLEANUP);
#line 620 "../libdeja/tools/duplicity/DuplicityJob.vala"
	cleanup_argv = NULL;
#line 621 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup ("cleanup");
#line 621 "../libdeja/tools/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp1_);
#line 622 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = g_strdup ("--force");
#line 622 "../libdeja/tools/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp2_);
#line 623 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = duplicity_job_get_remote (self, NULL);
#line 623 "../libdeja/tools/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp3_);
#line 625 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
#line 626 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = cleanup_argv;
#line 626 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, NULL, NULL, _tmp4_, NULL);
#line 628 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = TRUE;
#line 628 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(cleanup_argv == NULL) ? NULL : (cleanup_argv = (_g_list_free__g_free0_ (cleanup_argv), NULL));
#line 628 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 3630 "DuplicityJob.c"
}

static void
duplicity_job_delete_excess (DuplicityJob* self,
                             gint cutoff,
                             DejaDupBackend* backend_override)
{
	GList* argv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 631 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 632 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DELETE);
#line 633 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = NULL;
#line 634 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = g_strdup ("remove-all-but-n-full");
#line 634 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp0_);
#line 635 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup_printf ("%d", cutoff);
#line 635 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp1_);
#line 636 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = g_strdup ("--force");
#line 636 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp2_);
#line 637 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = duplicity_job_get_remote (self, backend_override);
#line 637 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp3_);
#line 639 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
#line 640 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, NULL, NULL, argv, NULL);
#line 642 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
#line 642 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return;
#line 3673 "DuplicityJob.c"
}

static gboolean
duplicity_job_can_ignore_error (DuplicityJob* self)
{
	gboolean result = FALSE;
	DuplicityJobState _tmp0_;
#line 645 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 652 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_state;
#line 652 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp0_ == DUPLICITY_JOB_STATE_CLEANUP;
#line 652 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 3689 "DuplicityJob.c"
}

static void
duplicity_job_handle_done (DuplicityJob* self,
                           DuplicityInstance* inst,
                           gboolean success,
                           gboolean cancelled)
{
	gchar* detail = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp46_;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	const gchar* _tmp50_;
#line 655 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 657 "../libdeja/tools/duplicity/DuplicityJob.vala"
	detail = NULL;
#line 659 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (duplicity_job_can_ignore_error (self)) {
#line 660 "../libdeja/tools/duplicity/DuplicityJob.vala"
		success = TRUE;
#line 3712 "DuplicityJob.c"
	}
#line 662 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!cancelled) {
#line 662 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = success;
#line 3718 "DuplicityJob.c"
	} else {
#line 662 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 3722 "DuplicityJob.c"
	}
#line 662 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 3726 "DuplicityJob.c"
		DuplicityJobState _tmp1_;
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->_state;
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (_tmp1_) {
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_DRY_RUN:
#line 3734 "DuplicityJob.c"
			{
#line 665 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->has_progress_total = TRUE;
#line 666 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->progress_total = self->priv->progress_count;
#line 667 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 668 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (detail);
#line 668 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 3746 "DuplicityJob.c"
				}
#line 669 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 3750 "DuplicityJob.c"
			}
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_DELETE:
#line 3754 "DuplicityJob.c"
			{
#line 672 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 673 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (detail);
#line 673 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 3762 "DuplicityJob.c"
				}
#line 674 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 3766 "DuplicityJob.c"
			}
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_CLEANUP:
#line 3770 "DuplicityJob.c"
			{
#line 677 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->cleaned_up_once = TRUE;
#line 678 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 679 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (detail);
#line 679 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 3780 "DuplicityJob.c"
				}
#line 683 "../libdeja/tools/duplicity/DuplicityJob.vala"
				success = FALSE;
#line 684 "../libdeja/tools/duplicity/DuplicityJob.vala"
				cancelled = TRUE;
#line 685 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 3788 "DuplicityJob.c"
			}
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_STATUS:
#line 3792 "DuplicityJob.c"
			{
				gboolean should_restart = FALSE;
				DejaDupToolJobMode _tmp2_;
				DejaDupToolJobMode _tmp3_;
				DejaDupToolJobMode _tmp4_;
				DejaDupToolJobMode _tmp5_;
#line 688 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->checked_collection_info = TRUE;
#line 689 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 689 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = _tmp2_;
#line 689 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp4_ = self->priv->_original_mode;
#line 689 "../libdeja/tools/duplicity/DuplicityJob.vala"
				should_restart = _tmp3_ != _tmp4_;
#line 690 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp5_ = self->priv->_original_mode;
#line 690 "../libdeja/tools/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp5_);
#line 692 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (should_restart) {
#line 693 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (duplicity_job_restart (self)) {
#line 694 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (detail);
#line 694 "../libdeja/tools/duplicity/DuplicityJob.vala"
						return;
#line 3821 "DuplicityJob.c"
					}
				}
#line 696 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 3826 "DuplicityJob.c"
			}
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_CHECK_CONTENTS:
#line 3830 "DuplicityJob.c"
			{
				DejaDupToolJobMode _tmp6_;
#line 699 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->has_checked_contents = TRUE;
#line 700 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp6_ = self->priv->_original_mode;
#line 700 "../libdeja/tools/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp6_);
#line 702 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 703 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (detail);
#line 703 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 3845 "DuplicityJob.c"
				}
#line 704 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 3849 "DuplicityJob.c"
			}
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_NORMAL:
#line 3853 "DuplicityJob.c"
			{
				gboolean _tmp7_ = FALSE;
				DejaDupToolJobMode _tmp8_;
				DejaDupToolJobMode _tmp9_;
				DejaDupToolJobMode _tmp15_;
				DejaDupToolJobMode _tmp16_;
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp8_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp9_ = _tmp8_;
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp9_ == DEJA_DUP_TOOL_JOB_MODE_RESTORE) {
#line 3866 "DuplicityJob.c"
					GList* _tmp10_;
					GList* _tmp11_;
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp10_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp11_ = _tmp10_;
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp7_ = _tmp11_ != NULL;
#line 3875 "DuplicityJob.c"
				} else {
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp7_ = FALSE;
#line 3879 "DuplicityJob.c"
				}
#line 707 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp7_) {
#line 3883 "DuplicityJob.c"
					GList* _tmp12_;
					GList* _tmp13_;
					GList* _tmp14_;
#line 708 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp12_ = ((DejaDupToolJob*) self)->_restore_files;
#line 708 "../libdeja/tools/duplicity/DuplicityJob.vala"
					((DejaDupToolJob*) self)->_restore_files = g_list_delete_link (((DejaDupToolJob*) self)->_restore_files, _tmp12_);
#line 709 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp13_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 709 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp14_ = _tmp13_;
#line 709 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp14_ != NULL) {
#line 710 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (duplicity_job_restart (self)) {
#line 711 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (detail);
#line 711 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return;
#line 3903 "DuplicityJob.c"
						}
					}
				}
#line 715 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp15_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 715 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp16_ = _tmp15_;
#line 715 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp16_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 3913 "DuplicityJob.c"
					GList* _tmp17_;
#line 716 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp17_ = self->priv->local_error_files;
#line 716 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp17_ != NULL) {
#line 3919 "DuplicityJob.c"
						gchar* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						GList* _tmp21_;
#line 720 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp18_ = g_strdup (_ ("Could not back up the following files.  Please make sure you are able " \
"to open them."));
#line 720 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (detail);
#line 720 "../libdeja/tools/duplicity/DuplicityJob.vala"
						detail = _tmp18_;
#line 721 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp19_ = detail;
#line 721 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp20_ = g_strconcat (_tmp19_, "\n", NULL);
#line 721 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (detail);
#line 721 "../libdeja/tools/duplicity/DuplicityJob.vala"
						detail = _tmp20_;
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp21_ = self->priv->local_error_files;
#line 3940 "DuplicityJob.c"
						{
							GList* f_collection = NULL;
							GList* f_it = NULL;
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
							f_collection = _tmp21_;
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
							for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 3948 "DuplicityJob.c"
								GFile* _tmp22_;
								GFile* f = NULL;
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp22_ = _g_object_ref0 ((GFile*) f_it->data);
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
								f = _tmp22_;
#line 3955 "DuplicityJob.c"
								{
									const gchar* _tmp23_;
									GFile* _tmp24_;
									gchar* _tmp25_;
									gchar* _tmp26_;
									gchar* _tmp27_;
									gchar* _tmp28_;
									gchar* _tmp29_;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp23_ = detail;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp24_ = f;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp25_ = g_file_get_parse_name (_tmp24_);
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp26_ = _tmp25_;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp27_ = g_strdup_printf ("\n%s", _tmp26_);
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp28_ = _tmp27_;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp29_ = g_strconcat (_tmp23_, _tmp28_, NULL);
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_g_free0 (detail);
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									detail = _tmp29_;
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_g_free0 (_tmp28_);
#line 723 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_g_free0 (_tmp26_);
#line 722 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_g_object_unref0 (f);
#line 3988 "DuplicityJob.c"
								}
							}
						}
					}
#line 727 "../libdeja/tools/duplicity/DuplicityJob.vala"
					deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 728 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (duplicity_job_delete_files_if_needed (self)) {
#line 729 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (detail);
#line 729 "../libdeja/tools/duplicity/DuplicityJob.vala"
						return;
#line 4001 "DuplicityJob.c"
					}
				} else {
					DejaDupToolJobMode _tmp30_;
					DejaDupToolJobMode _tmp31_;
#line 731 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp30_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 731 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp31_ = _tmp30_;
#line 731 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp31_ == DEJA_DUP_TOOL_JOB_MODE_RESTORE) {
#line 4012 "DuplicityJob.c"
						GList* _tmp32_;
#line 732 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp32_ = self->priv->local_error_files;
#line 732 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp32_ != NULL) {
#line 4018 "DuplicityJob.c"
							gchar* _tmp33_;
							const gchar* _tmp34_;
							gchar* _tmp35_;
							GList* _tmp36_;
#line 736 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp33_ = g_strdup (_ ("Could not restore the following files.  Please make sure you are able " \
"to write to them."));
#line 736 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (detail);
#line 736 "../libdeja/tools/duplicity/DuplicityJob.vala"
							detail = _tmp33_;
#line 737 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp34_ = detail;
#line 737 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp35_ = g_strconcat (_tmp34_, "\n", NULL);
#line 737 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (detail);
#line 737 "../libdeja/tools/duplicity/DuplicityJob.vala"
							detail = _tmp35_;
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp36_ = self->priv->local_error_files;
#line 4039 "DuplicityJob.c"
							{
								GList* f_collection = NULL;
								GList* f_it = NULL;
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
								f_collection = _tmp36_;
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
								for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 4047 "DuplicityJob.c"
									GFile* _tmp37_;
									GFile* f = NULL;
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp37_ = _g_object_ref0 ((GFile*) f_it->data);
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
									f = _tmp37_;
#line 4054 "DuplicityJob.c"
									{
										const gchar* _tmp38_;
										GFile* _tmp39_;
										gchar* _tmp40_;
										gchar* _tmp41_;
										gchar* _tmp42_;
										gchar* _tmp43_;
										gchar* _tmp44_;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp38_ = detail;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp39_ = f;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp40_ = g_file_get_parse_name (_tmp39_);
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp41_ = _tmp40_;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp42_ = g_strdup_printf ("\n%s", _tmp41_);
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp43_ = _tmp42_;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_tmp44_ = g_strconcat (_tmp38_, _tmp43_, NULL);
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_g_free0 (detail);
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										detail = _tmp44_;
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_g_free0 (_tmp43_);
#line 739 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_g_free0 (_tmp41_);
#line 738 "../libdeja/tools/duplicity/DuplicityJob.vala"
										_g_object_unref0 (f);
#line 4087 "DuplicityJob.c"
									}
								}
							}
						}
					}
				}
#line 743 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 4096 "DuplicityJob.c"
			}
			default:
#line 663 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 4101 "DuplicityJob.c"
		}
	} else {
		gboolean _tmp45_;
#line 746 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp45_ = self->priv->_was_stopped;
#line 746 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp45_) {
#line 747 "../libdeja/tools/duplicity/DuplicityJob.vala"
			success = TRUE;
#line 4111 "DuplicityJob.c"
		}
	}
#line 749 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp46_ = self->priv->_error_issued;
#line 749 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp46_) {
#line 750 "../libdeja/tools/duplicity/DuplicityJob.vala"
		success = FALSE;
#line 4120 "DuplicityJob.c"
	}
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!success) {
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp48_ = !cancelled;
#line 4126 "DuplicityJob.c"
	} else {
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp48_ = FALSE;
#line 4130 "DuplicityJob.c"
	}
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp48_) {
#line 4134 "DuplicityJob.c"
		gboolean _tmp49_;
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp49_ = self->priv->_error_issued;
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp47_ = !_tmp49_;
#line 4140 "DuplicityJob.c"
	} else {
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp47_ = FALSE;
#line 4144 "DuplicityJob.c"
	}
#line 752 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp47_) {
#line 753 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), NULL);
#line 4150 "DuplicityJob.c"
	}
#line 755 "../libdeja/tools/duplicity/DuplicityJob.vala"
	inst = NULL;
#line 756 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp50_ = detail;
#line 756 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "done", success, cancelled, _tmp50_);
#line 655 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (detail);
#line 4160 "DuplicityJob.c"
}

static void
duplicity_job_set_status (DuplicityJob* self,
                          const gchar* msg,
                          gboolean save)
{
#line 762 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 762 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (msg != NULL);
#line 764 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (save) {
#line 4174 "DuplicityJob.c"
		gchar* _tmp0_;
#line 765 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = g_strdup (msg);
#line 765 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (self->priv->saved_status);
#line 765 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->saved_status = _tmp0_;
#line 766 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->saved_status_file);
#line 766 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file = NULL;
#line 4186 "DuplicityJob.c"
	}
#line 768 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-desc-changed", msg);
#line 4190 "DuplicityJob.c"
}

static void
duplicity_job_set_status_file (DuplicityJob* self,
                               GFile* file,
                               gboolean action,
                               gboolean save)
{
#line 771 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 771 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 773 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (save) {
#line 4205 "DuplicityJob.c"
		GFile* _tmp0_;
#line 774 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (self->priv->saved_status);
#line 774 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->saved_status = NULL;
#line 775 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = _g_object_ref0 (file);
#line 775 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->saved_status_file);
#line 775 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file = _tmp0_;
#line 776 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file_action = action;
#line 4219 "DuplicityJob.c"
	}
#line 778 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-file-changed", file, action);
#line 4223 "DuplicityJob.c"
}

static void
duplicity_job_set_saved_status (DuplicityJob* self)
{
	const gchar* _tmp0_;
#line 781 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 783 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->saved_status;
#line 783 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 4236 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 784 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->saved_status;
#line 784 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_status (self, _tmp1_, FALSE);
#line 4242 "DuplicityJob.c"
	} else {
		GFile* _tmp2_;
#line 786 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = self->priv->saved_status_file;
#line 786 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp2_, self->priv->saved_status_file_action, FALSE);
#line 4249 "DuplicityJob.c"
	}
}

static gboolean
duplicity_job_delete_files_if_needed (DuplicityJob* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 790 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 792 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (self->priv->delete_age == 0) {
#line 793 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->deleted_files = TRUE;
#line 794 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 794 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4268 "DuplicityJob.c"
	}
#line 800 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (self->priv->got_collection_info) {
#line 800 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = !self->priv->deleted_files;
#line 4274 "DuplicityJob.c"
	} else {
#line 800 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 4278 "DuplicityJob.c"
	}
#line 800 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 4282 "DuplicityJob.c"
		gint full_dates = 0;
		GTimeVal prev_time = {0};
		GDate prev_date = {0};
		gint too_old = 0;
		GTimeVal now = {0};
		GDate today = {0};
		GTimeVal _tmp1_;
		GList* _tmp2_;
		GTimeVal _tmp8_;
		GDate _tmp9_;
		gboolean _tmp10_ = FALSE;
#line 802 "../libdeja/tools/duplicity/DuplicityJob.vala"
		full_dates = 0;
#line 803 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_get_current_time (&prev_time);
#line 804 "../libdeja/tools/duplicity/DuplicityJob.vala"
		memset (&prev_date, 0, sizeof (GDate));
#line 805 "../libdeja/tools/duplicity/DuplicityJob.vala"
		too_old = 0;
#line 806 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_get_current_time (&now);
#line 807 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_get_current_time (&now);
#line 809 "../libdeja/tools/duplicity/DuplicityJob.vala"
		memset (&today, 0, sizeof (GDate));
#line 810 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = now;
#line 810 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_date_set_time_val (&today, &_tmp1_);
#line 812 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = self->priv->collection_info;
#line 4314 "DuplicityJob.c"
		{
			GList* info_collection = NULL;
			GList* info_it = NULL;
#line 812 "../libdeja/tools/duplicity/DuplicityJob.vala"
			info_collection = _tmp2_;
#line 812 "../libdeja/tools/duplicity/DuplicityJob.vala"
			for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
#line 4322 "DuplicityJob.c"
				DuplicityJobDateInfo info = {0};
#line 812 "../libdeja/tools/duplicity/DuplicityJob.vala"
				info = *((DuplicityJobDateInfo*) info_it->data);
#line 4326 "DuplicityJob.c"
				{
					DuplicityJobDateInfo _tmp3_;
					DuplicityJobDateInfo _tmp6_;
					GTimeVal _tmp7_;
#line 813 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp3_ = info;
#line 813 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp3_.full) {
#line 814 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (full_dates > 0) {
#line 4337 "DuplicityJob.c"
							GTimeVal _tmp4_;
							GDate _tmp5_;
#line 815 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp4_ = prev_time;
#line 815 "../libdeja/tools/duplicity/DuplicityJob.vala"
							g_date_set_time_val (&prev_date, &_tmp4_);
#line 816 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp5_ = today;
#line 816 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (g_date_days_between (&prev_date, &_tmp5_) > self->priv->delete_age) {
#line 817 "../libdeja/tools/duplicity/DuplicityJob.vala"
								too_old = too_old + 1;
#line 4350 "DuplicityJob.c"
							}
						}
#line 819 "../libdeja/tools/duplicity/DuplicityJob.vala"
						full_dates = full_dates + 1;
#line 4355 "DuplicityJob.c"
					}
#line 821 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = info;
#line 821 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp7_ = _tmp6_.time;
#line 821 "../libdeja/tools/duplicity/DuplicityJob.vala"
					prev_time = _tmp7_;
#line 4363 "DuplicityJob.c"
				}
			}
		}
#line 823 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp8_ = prev_time;
#line 823 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_date_set_time_val (&prev_date, &_tmp8_);
#line 824 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp9_ = today;
#line 824 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (g_date_days_between (&prev_date, &_tmp9_) > self->priv->delete_age) {
#line 825 "../libdeja/tools/duplicity/DuplicityJob.vala"
			too_old = too_old + 1;
#line 4377 "DuplicityJob.c"
		}
#line 830 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (self->priv->is_full_backup) {
#line 831 "../libdeja/tools/duplicity/DuplicityJob.vala"
			full_dates = full_dates + 1;
#line 4383 "DuplicityJob.c"
		}
#line 833 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (too_old > 0) {
#line 833 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp10_ = full_dates > DUPLICITY_JOB_MINIMUM_FULL;
#line 4389 "DuplicityJob.c"
		} else {
#line 833 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp10_ = FALSE;
#line 4393 "DuplicityJob.c"
		}
#line 833 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp10_) {
#line 4397 "DuplicityJob.c"
			gint cutoff = 0;
#line 835 "../libdeja/tools/duplicity/DuplicityJob.vala"
			cutoff = MAX (DUPLICITY_JOB_MINIMUM_FULL, full_dates - too_old);
#line 836 "../libdeja/tools/duplicity/DuplicityJob.vala"
			duplicity_job_delete_excess (self, cutoff, NULL);
#line 837 "../libdeja/tools/duplicity/DuplicityJob.vala"
			result = TRUE;
#line 837 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return result;
#line 4407 "DuplicityJob.c"
		}
#line 841 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->deleted_files = TRUE;
#line 842 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 842 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4415 "DuplicityJob.c"
	} else {
#line 845 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 845 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4421 "DuplicityJob.c"
	}
}

static void
duplicity_job_delete_cache (DuplicityJob* self)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* cachedir = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	DejaDupRecursiveDelete* del = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	DejaDupRecursiveDelete* _tmp8_;
	DejaDupRecursiveDelete* _tmp9_;
	DejaDupRecursiveDelete* _tmp10_;
#line 879 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 881 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 881 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 881 "../libdeja/tools/duplicity/DuplicityJob.vala"
	dir = _tmp1_;
#line 882 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = dir;
#line 882 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ == NULL) {
#line 883 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (dir);
#line 883 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 4458 "DuplicityJob.c"
	}
#line 885 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = dir;
#line 885 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp4_ = g_build_filename (_tmp3_, PACKAGE, NULL);
#line 885 "../libdeja/tools/duplicity/DuplicityJob.vala"
	cachedir = _tmp4_;
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = cachedir;
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp7_ = _tmp6_;
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp8_ = deja_dup_recursive_delete_new (_tmp7_, "metadata");
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp9_ = _tmp8_;
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp7_);
#line 886 "../libdeja/tools/duplicity/DuplicityJob.vala"
	del = _tmp9_;
#line 887 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp10_ = del;
#line 887 "../libdeja/tools/duplicity/DuplicityJob.vala"
	deja_dup_recursive_op_start ((DejaDupRecursiveOp*) _tmp10_);
#line 879 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (del);
#line 879 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (cachedir);
#line 879 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (dir);
#line 4490 "DuplicityJob.c"
}

static gboolean
duplicity_job_restart_without_cache (DuplicityJob* self)
{
	gboolean result = FALSE;
#line 891 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 893 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (self->priv->restarted_without_cache) {
#line 894 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 894 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4505 "DuplicityJob.c"
	}
#line 896 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->restarted_without_cache = TRUE;
#line 898 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_delete_cache (self);
#line 899 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = duplicity_job_restart (self);
#line 899 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 4515 "DuplicityJob.c"
}

static void
duplicity_job_handle_exit (DuplicityJob* self,
                           gint code)
{
	gboolean _tmp0_ = FALSE;
#line 902 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 910 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (code == DUPLICITY_JOB_ERROR_GENERIC) {
#line 4527 "DuplicityJob.c"
		gboolean _tmp1_;
#line 910 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->_error_issued;
#line 910 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = !_tmp1_;
#line 4533 "DuplicityJob.c"
	} else {
#line 910 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 4537 "DuplicityJob.c"
	}
#line 910 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 911 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_restart_without_cache (self);
#line 4543 "DuplicityJob.c"
	}
}

static void
duplicity_job_handle_message (DuplicityJob* self,
                              DuplicityInstance* inst,
                              gchar** control_line,
                              gint control_line_length1,
                              GList* data_lines,
                              const gchar* user_text)
{
	gchar* keyword = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label0 = 0;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label1 = 0;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label2 = 0;
#line 915 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 915 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (inst != NULL);
#line 915 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (user_text != NULL);
#line 921 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (control_line_length1 == 0) {
#line 922 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 4577 "DuplicityJob.c"
	}
#line 924 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = control_line[0];
#line 924 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 924 "../libdeja/tools/duplicity/DuplicityJob.vala"
	keyword = _tmp1_;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = keyword;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("ERROR")))) {
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4595 "DuplicityJob.c"
			default:
			{
#line 927 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_error (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 928 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 4602 "DuplicityJob.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("INFO")))) {
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4608 "DuplicityJob.c"
			default:
			{
#line 930 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_info (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 931 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 4615 "DuplicityJob.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("WARNING")))) {
#line 925 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4621 "DuplicityJob.c"
			default:
			{
#line 933 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_warning (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 934 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 4628 "DuplicityJob.c"
			}
		}
	}
#line 915 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (keyword);
#line 4634 "DuplicityJob.c"
}

static gboolean
duplicity_job_ask_question (DuplicityJob* self,
                            const gchar* t,
                            const gchar* m)
{
	gboolean result = FALSE;
	gboolean rv = FALSE;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
#line 938 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 938 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (t != NULL, FALSE);
#line 938 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 940 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 941 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "question", t, m);
#line 942 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 942 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 942 "../libdeja/tools/duplicity/DuplicityJob.vala"
	rv = _tmp1_ != DEJA_DUP_TOOL_JOB_MODE_INVALID;
#line 943 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!rv) {
#line 944 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_handle_done (self, NULL, FALSE, TRUE);
#line 4666 "DuplicityJob.c"
	}
#line 945 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = rv;
#line 945 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 4672 "DuplicityJob.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 4694 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 4702 "DuplicityJob.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 4708 "DuplicityJob.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 4732 "DuplicityJob.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 4741 "DuplicityJob.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4760 "DuplicityJob.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4764 "DuplicityJob.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4770 "DuplicityJob.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4780 "DuplicityJob.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4788 "DuplicityJob.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4792 "DuplicityJob.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 4798 "DuplicityJob.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 4808 "DuplicityJob.c"
}

static gchar*
duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                    const gchar* file,
                                    gint skip_bits)
{
	gchar* result = NULL;
	gint next = 0;
#line 950 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 950 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 952 "../libdeja/tools/duplicity/DuplicityJob.vala"
	next = 0;
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
	while (TRUE) {
#line 4826 "DuplicityJob.c"
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = skip_bits;
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
		skip_bits = _tmp1_ - 1;
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp1_ > 0) {
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp0_ = next >= 0;
#line 4837 "DuplicityJob.c"
		} else {
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp0_ = FALSE;
#line 4841 "DuplicityJob.c"
		}
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (!_tmp0_) {
#line 953 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 4847 "DuplicityJob.c"
		}
#line 954 "../libdeja/tools/duplicity/DuplicityJob.vala"
		next = string_index_of_char (file, (gunichar) '.', next) + 1;
#line 4851 "DuplicityJob.c"
	}
#line 955 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (next < 0) {
#line 4855 "DuplicityJob.c"
		gchar* _tmp2_;
#line 956 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = g_strdup ("");
#line 956 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = _tmp2_;
#line 956 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4863 "DuplicityJob.c"
	} else {
		gchar* _tmp3_;
#line 958 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = string_substring (file, (glong) next, (glong) -1);
#line 958 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = _tmp3_;
#line 958 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4872 "DuplicityJob.c"
	}
}

static void
duplicity_job_report_encryption_error (DuplicityJob* self)
{
#line 961 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 963 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "bad-encryption-password");
#line 964 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_show_error (self, _ ("Bad encryption password."), NULL);
#line 4885 "DuplicityJob.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 4904 "DuplicityJob.c"
}

static gboolean
duplicity_job_check_encryption_error (DuplicityJob* self,
                                      const gchar* text)
{
	gboolean result = FALSE;
	gchar* no_seckey_msg = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* bad_key_msg = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 967 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 967 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 974 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = gpg_strerror (GPG_ERR_NO_SECKEY);
#line 974 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 974 "../libdeja/tools/duplicity/DuplicityJob.vala"
	no_seckey_msg = _tmp1_;
#line 975 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = gpg_strerror (GPG_ERR_BAD_KEY);
#line 975 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 975 "../libdeja/tools/duplicity/DuplicityJob.vala"
	bad_key_msg = _tmp3_;
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = no_seckey_msg;
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (string_contains (text, _tmp5_)) {
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = TRUE;
#line 4942 "DuplicityJob.c"
	} else {
		const gchar* _tmp6_;
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp6_ = bad_key_msg;
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = string_contains (text, _tmp6_);
#line 4949 "DuplicityJob.c"
	}
#line 976 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp4_) {
#line 977 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_report_encryption_error (self);
#line 978 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = TRUE;
#line 978 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (bad_key_msg);
#line 978 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (no_seckey_msg);
#line 978 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 4963 "DuplicityJob.c"
	}
#line 981 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = FALSE;
#line 981 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (bad_key_msg);
#line 981 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (no_seckey_msg);
#line 981 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 4973 "DuplicityJob.c"
}

static void
duplicity_job_real_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  gint firstline_length1,
                                  GList* data,
                                  const gchar* text_in)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp72_;
#line 984 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (text_in != NULL);
#line 987 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = g_strdup (text_in);
#line 987 "../libdeja/tools/duplicity/DuplicityJob.vala"
	text = _tmp0_;
#line 989 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (duplicity_job_can_ignore_error (self)) {
#line 990 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_free0 (text);
#line 990 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 4998 "DuplicityJob.c"
	}
#line 992 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 5002 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = firstline[1];
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp1_)) {
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_GENERIC:
#line 5010 "DuplicityJob.c"
			{
				gboolean _tmp2_ = FALSE;
				const gchar* _tmp3_;
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = text;
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (string_contains (_tmp3_, "GnuPG")) {
#line 5018 "DuplicityJob.c"
					const gchar* _tmp4_;
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp4_ = text;
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp2_ = duplicity_job_check_encryption_error (self, _tmp4_);
#line 5024 "DuplicityJob.c"
				} else {
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp2_ = FALSE;
#line 5028 "DuplicityJob.c"
				}
#line 996 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp2_) {
#line 997 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 997 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 5036 "DuplicityJob.c"
				}
#line 998 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5040 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_EXCEPTION:
#line 5044 "DuplicityJob.c"
			{
				const gchar* _tmp5_ = NULL;
				const gchar* _tmp7_;
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 5050 "DuplicityJob.c"
					const gchar* _tmp6_;
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = firstline[2];
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp5_ = _tmp6_;
#line 5056 "DuplicityJob.c"
				} else {
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp5_ = "";
#line 5060 "DuplicityJob.c"
				}
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp7_ = text;
#line 1001 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_exception (self, _tmp5_, _tmp7_);
#line 1002 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (text);
#line 1002 "../libdeja/tools/duplicity/DuplicityJob.vala"
				return;
#line 5070 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND:
#line 5074 "DuplicityJob.c"
			{
				GList* _tmp8_;
				GList* _tmp9_;
#line 1008 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp8_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 1008 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp9_ = _tmp8_;
#line 1008 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp9_ != NULL) {
#line 5084 "DuplicityJob.c"
					GList* _tmp10_;
					GList* _tmp11_;
					gconstpointer _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp10_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp11_ = _tmp10_;
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp12_ = _tmp11_->data;
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp13_ = g_file_get_parse_name ((GFile*) _tmp12_);
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp14_ = _tmp13_;
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp15_ = g_strdup_printf (_ ("Could not restore ‘%s’: File not found in backup"), _tmp14_);
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					text = _tmp15_;
#line 1009 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp14_);
#line 5109 "DuplicityJob.c"
				}
#line 1011 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5113 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_GPG:
#line 5117 "DuplicityJob.c"
			{
#line 1014 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_check_encryption_error (self, text_in)) {
#line 1015 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1015 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 5125 "DuplicityJob.c"
				}
#line 1016 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5129 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED:
#line 5133 "DuplicityJob.c"
			{
				gchar* _tmp21_;
#line 1019 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 4) {
#line 5138 "DuplicityJob.c"
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gboolean _tmp20_;
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp16_ = firstline[3];
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp17_ = firstline[2];
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp18_ = g_strdup_printf (_ ("The existing backup is of a computer named %s, but the current compute" \
"r’s name is %s.  If this is unexpected, you should back up to a differ" \
"ent location."), _tmp16_, _tmp17_);
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp19_ = _tmp18_;
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp20_ = !duplicity_job_ask_question (self, _ ("Computer name changed"), _tmp19_);
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp19_);
#line 1020 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp20_) {
#line 1021 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 1021 "../libdeja/tools/duplicity/DuplicityJob.vala"
						return;
#line 5162 "DuplicityJob.c"
					}
				}
#line 1025 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp21_ = g_strdup ("--allow-source-mismatch");
#line 1025 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp21_);
#line 1026 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 1027 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1027 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 5175 "DuplicityJob.c"
				}
#line 1028 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5179 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BAD_VOLUME:
#line 5183 "DuplicityJob.c"
			{
				DejaDupToolJobMode _tmp22_;
				DejaDupToolJobMode _tmp23_;
#line 1036 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp22_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1036 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp23_ = _tmp22_;
#line 1036 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp23_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5193 "DuplicityJob.c"
					gchar* this_volume = NULL;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					gboolean _tmp30_ = FALSE;
					gboolean _tmp31_ = FALSE;
#line 1038 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp24_ = firstline[2];
#line 1038 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp25_ = duplicity_job_parse_duplicity_file (self, _tmp24_, 2);
#line 1038 "../libdeja/tools/duplicity/DuplicityJob.vala"
					this_volume = _tmp25_;
#line 1039 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp26_ = self->priv->last_bad_volume;
#line 1039 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp27_ = this_volume;
#line 1039 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (g_strcmp0 (_tmp26_, _tmp27_) != 0) {
#line 5213 "DuplicityJob.c"
						const gchar* _tmp28_;
						gchar* _tmp29_;
#line 1040 "../libdeja/tools/duplicity/DuplicityJob.vala"
						self->priv->bad_volume_count = (guint) 0;
#line 1041 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp28_ = this_volume;
#line 1041 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 1041 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (self->priv->last_bad_volume);
#line 1041 "../libdeja/tools/duplicity/DuplicityJob.vala"
						self->priv->last_bad_volume = _tmp29_;
#line 5226 "DuplicityJob.c"
					}
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (self->priv->bad_volume_count == ((guint) 0)) {
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp31_ = duplicity_job_restart (self);
#line 5232 "DuplicityJob.c"
					} else {
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp31_ = FALSE;
#line 5236 "DuplicityJob.c"
					}
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp31_) {
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp30_ = TRUE;
#line 5242 "DuplicityJob.c"
					} else {
						gboolean _tmp32_ = FALSE;
#line 1045 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (self->priv->bad_volume_count == ((guint) 1)) {
#line 1045 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp32_ = duplicity_job_cleanup (self);
#line 5249 "DuplicityJob.c"
						} else {
#line 1045 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp32_ = FALSE;
#line 5253 "DuplicityJob.c"
						}
#line 1045 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp30_ = _tmp32_;
#line 5257 "DuplicityJob.c"
					}
#line 1044 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp30_) {
#line 1046 "../libdeja/tools/duplicity/DuplicityJob.vala"
						self->priv->bad_volume_count = self->priv->bad_volume_count + 1;
#line 1047 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (this_volume);
#line 1047 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 1047 "../libdeja/tools/duplicity/DuplicityJob.vala"
						return;
#line 5269 "DuplicityJob.c"
					}
#line 1036 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (this_volume);
#line 5273 "DuplicityJob.c"
				}
#line 1050 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5277 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED:
#line 5281 "DuplicityJob.c"
			{
				gboolean _tmp33_ = FALSE;
				gboolean _tmp41_ = FALSE;
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5287 "DuplicityJob.c"
					const gchar* _tmp34_;
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp34_ = firstline[2];
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp33_ = g_strcmp0 (_tmp34_, "put") == 0;
#line 5293 "DuplicityJob.c"
				} else {
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp33_ = FALSE;
#line 5297 "DuplicityJob.c"
				}
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp33_) {
#line 5301 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp35_;
					GFile* _tmp36_;
					GFile* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
#line 1054 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp35_ = firstline[4];
#line 1054 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp36_ = duplicity_job_make_file_obj (self, _tmp35_);
#line 1054 "../libdeja/tools/duplicity/DuplicityJob.vala"
					file = _tmp36_;
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp37_ = file;
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp38_ = g_file_get_parse_name (_tmp37_);
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp39_ = _tmp38_;
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp40_ = g_strdup_printf (_ ("Permission denied when trying to create ‘%s’."), _tmp39_);
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					text = _tmp40_;
#line 1055 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp39_);
#line 1053 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5331 "DuplicityJob.c"
				}
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5335 "DuplicityJob.c"
					const gchar* _tmp42_;
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp42_ = firstline[2];
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp41_ = g_strcmp0 (_tmp42_, "get") == 0;
#line 5341 "DuplicityJob.c"
				} else {
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp41_ = FALSE;
#line 5345 "DuplicityJob.c"
				}
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp41_) {
#line 5349 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp43_;
					GFile* _tmp44_;
					GFile* _tmp45_;
					gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
#line 1058 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp43_ = firstline[3];
#line 1058 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp44_ = duplicity_job_make_file_obj (self, _tmp43_);
#line 1058 "../libdeja/tools/duplicity/DuplicityJob.vala"
					file = _tmp44_;
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp45_ = file;
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp46_ = g_file_get_parse_name (_tmp45_);
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp47_ = _tmp46_;
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp48_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp47_);
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					text = _tmp48_;
#line 1059 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp47_);
#line 1057 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5379 "DuplicityJob.c"
				} else {
					gboolean _tmp49_ = FALSE;
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (firstline_length1 >= 4) {
#line 5384 "DuplicityJob.c"
						const gchar* _tmp50_;
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp50_ = firstline[2];
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp49_ = g_strcmp0 (_tmp50_, "list") == 0;
#line 5390 "DuplicityJob.c"
					} else {
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp49_ = FALSE;
#line 5394 "DuplicityJob.c"
					}
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp49_) {
#line 5398 "DuplicityJob.c"
						GFile* file = NULL;
						const gchar* _tmp51_;
						GFile* _tmp52_;
						GFile* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						gchar* _tmp56_;
#line 1062 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp51_ = firstline[3];
#line 1062 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp52_ = duplicity_job_make_file_obj (self, _tmp51_);
#line 1062 "../libdeja/tools/duplicity/DuplicityJob.vala"
						file = _tmp52_;
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp53_ = file;
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp54_ = g_file_get_parse_name (_tmp53_);
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp55_ = _tmp54_;
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp56_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp55_);
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						text = _tmp56_;
#line 1063 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_free0 (_tmp55_);
#line 1061 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_g_object_unref0 (file);
#line 5428 "DuplicityJob.c"
					} else {
						gboolean _tmp57_ = FALSE;
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (firstline_length1 >= 4) {
#line 5433 "DuplicityJob.c"
							const gchar* _tmp58_;
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp58_ = firstline[2];
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp57_ = g_strcmp0 (_tmp58_, "delete") == 0;
#line 5439 "DuplicityJob.c"
						} else {
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp57_ = FALSE;
#line 5443 "DuplicityJob.c"
						}
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp57_) {
#line 5447 "DuplicityJob.c"
							GFile* file = NULL;
							const gchar* _tmp59_;
							GFile* _tmp60_;
							GFile* _tmp61_;
							gchar* _tmp62_;
							gchar* _tmp63_;
							gchar* _tmp64_;
#line 1066 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp59_ = firstline[3];
#line 1066 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp60_ = duplicity_job_make_file_obj (self, _tmp59_);
#line 1066 "../libdeja/tools/duplicity/DuplicityJob.vala"
							file = _tmp60_;
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp61_ = file;
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp62_ = g_file_get_parse_name (_tmp61_);
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp63_ = _tmp62_;
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp64_ = g_strdup_printf (_ ("Permission denied when trying to delete ‘%s’."), _tmp63_);
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (text);
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							text = _tmp64_;
#line 1067 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp63_);
#line 1065 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_object_unref0 (file);
#line 5477 "DuplicityJob.c"
						}
					}
				}
#line 1069 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5483 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND:
#line 5487 "DuplicityJob.c"
			{
#line 1072 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 4) {
#line 5491 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp65_;
					GFile* _tmp66_;
					GFile* _tmp67_;
					gchar* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
#line 1073 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp65_ = firstline[3];
#line 1073 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp66_ = duplicity_job_make_file_obj (self, _tmp65_);
#line 1073 "../libdeja/tools/duplicity/DuplicityJob.vala"
					file = _tmp66_;
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp67_ = file;
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp68_ = g_file_get_parse_name (_tmp67_);
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp69_ = _tmp68_;
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp70_ = g_strdup_printf (_ ("Backup location ‘%s’ does not exist."), _tmp69_);
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					text = _tmp70_;
#line 1074 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp69_);
#line 1072 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5521 "DuplicityJob.c"
				}
#line 1076 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5525 "DuplicityJob.c"
			}
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE:
#line 5529 "DuplicityJob.c"
			{
#line 1079 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5533 "DuplicityJob.c"
					gchar* _tmp71_;
#line 1080 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp71_ = g_strdup (_ ("No space left."));
#line 1080 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 1080 "../libdeja/tools/duplicity/DuplicityJob.vala"
					text = _tmp71_;
#line 5541 "DuplicityJob.c"
				}
#line 1082 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5545 "DuplicityJob.c"
			}
			default:
#line 993 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 5550 "DuplicityJob.c"
		}
	}
#line 1086 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp72_ = text;
#line 1086 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_show_error (self, _tmp72_, NULL);
#line 984 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (text);
#line 5559 "DuplicityJob.c"
}

void
duplicity_job_process_error (DuplicityJob* self,
                             gchar** firstline,
                             gint firstline_length1,
                             GList* data,
                             const gchar* text_in)
{
#line 984 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 984 "../libdeja/tools/duplicity/DuplicityJob.vala"
	DUPLICITY_JOB_GET_CLASS (self)->process_error (self, firstline, firstline_length1, data, text_in);
#line 5573 "DuplicityJob.c"
}

static void
duplicity_job_process_exception (DuplicityJob* self,
                                 const gchar* exception,
                                 const gchar* text)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label0 = 0;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label1 = 0;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label2 = 0;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label3 = 0;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label4 = 0;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label5 = 0;
#line 5595 "DuplicityJob.c"
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
#line 1089 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1089 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (exception != NULL);
#line 1089 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = exception;
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("S3ResponseError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5612 "DuplicityJob.c"
			default:
			{
#line 1093 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (string_contains (text, "<Code>InvalidAccessKeyId</Code>")) {
#line 1094 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_show_error (self, _ ("Invalid ID."), NULL);
#line 5619 "DuplicityJob.c"
				} else {
#line 1095 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (string_contains (text, "<Code>SignatureDoesNotMatch</Code>")) {
#line 1096 "../libdeja/tools/duplicity/DuplicityJob.vala"
						duplicity_job_show_error (self, _ ("Invalid secret key."), NULL);
#line 5625 "DuplicityJob.c"
					} else {
#line 1097 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (string_contains (text, "<Code>NotSignedUp</Code>")) {
#line 1098 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _ ("Your Amazon Web Services account is not signed up for the S3 service."), NULL);
#line 5631 "DuplicityJob.c"
						}
					}
				}
#line 1099 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5637 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("S3CreateError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5643 "DuplicityJob.c"
			default:
			{
#line 1101 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (string_contains (text, "<Code>BucketAlreadyExists</Code>")) {
#line 5648 "DuplicityJob.c"
					DejaDupBackend* _tmp3_;
					DejaDupBackend* _tmp4_;
#line 1102 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1102 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp4_ = _tmp3_;
#line 1102 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (deja_dup_backend_s3_bump_bucket (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3))) {
#line 1103 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (duplicity_job_restart (self)) {
#line 1104 "../libdeja/tools/duplicity/DuplicityJob.vala"
							return;
#line 5661 "DuplicityJob.c"
						}
					}
#line 1107 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_show_error (self, _ ("S3 bucket name is not available."), NULL);
#line 5666 "DuplicityJob.c"
				}
#line 1109 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5670 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("EOFError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5676 "DuplicityJob.c"
			default:
			{
#line 1112 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_report_encryption_error (self);
#line 1113 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5683 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("IOError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5689 "DuplicityJob.c"
			default:
			{
#line 1115 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (string_contains (text, "GnuPG")) {
#line 1116 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_report_encryption_error (self);
#line 5696 "DuplicityJob.c"
				} else {
					gboolean _tmp5_ = FALSE;
#line 1117 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (string_contains (text, "[Errno 5]")) {
#line 5701 "DuplicityJob.c"
						GFile* _tmp6_;
#line 1118 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp6_ = self->priv->last_touched_file;
#line 1118 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp5_ = _tmp6_ != NULL;
#line 5707 "DuplicityJob.c"
					} else {
#line 1117 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp5_ = FALSE;
#line 5711 "DuplicityJob.c"
					}
#line 1117 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp5_) {
#line 5715 "DuplicityJob.c"
						DejaDupToolJobMode _tmp7_;
						DejaDupToolJobMode _tmp8_;
#line 1119 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp7_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1119 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp8_ = _tmp7_;
#line 1119 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp8_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5724 "DuplicityJob.c"
							GFile* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp9_ = self->priv->last_touched_file;
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp10_ = g_file_get_parse_name (_tmp9_);
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp11_ = _tmp10_;
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp12_ = g_strdup_printf (_ ("Error reading file ‘%s’."), _tmp11_);
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp13_ = _tmp12_;
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp13_, NULL);
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp13_);
#line 1120 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp11_);
#line 5746 "DuplicityJob.c"
						} else {
							GFile* _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
							gchar* _tmp17_;
							gchar* _tmp18_;
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp14_ = self->priv->last_touched_file;
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp15_ = g_file_get_parse_name (_tmp14_);
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp16_ = _tmp15_;
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp17_ = g_strdup_printf (_ ("Error writing file ‘%s’."), _tmp16_);
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp18_ = _tmp17_;
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp18_, NULL);
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp18_);
#line 1122 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp16_);
#line 5769 "DuplicityJob.c"
						}
					} else {
#line 1124 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (string_contains (text, "[Errno 28]")) {
#line 5774 "DuplicityJob.c"
							gchar* where = NULL;
							DejaDupToolJobMode _tmp19_;
							DejaDupToolJobMode _tmp20_;
							const gchar* _tmp27_;
#line 1125 "../libdeja/tools/duplicity/DuplicityJob.vala"
							where = NULL;
#line 1126 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp19_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1126 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp20_ = _tmp19_;
#line 1126 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (_tmp20_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5787 "DuplicityJob.c"
								DejaDupBackend* _tmp21_;
								DejaDupBackend* _tmp22_;
								gchar* _tmp23_;
#line 1127 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp21_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1127 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp22_ = _tmp21_;
#line 1127 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp23_ = deja_dup_backend_get_location_pretty (_tmp22_);
#line 1127 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (where);
#line 1127 "../libdeja/tools/duplicity/DuplicityJob.vala"
								where = _tmp23_;
#line 5801 "DuplicityJob.c"
							} else {
								GFile* _tmp24_;
								GFile* _tmp25_;
								gchar* _tmp26_;
#line 1129 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp24_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 1129 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp25_ = _tmp24_;
#line 1129 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp26_ = g_file_get_path (_tmp25_);
#line 1129 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (where);
#line 1129 "../libdeja/tools/duplicity/DuplicityJob.vala"
								where = _tmp26_;
#line 5816 "DuplicityJob.c"
							}
#line 1130 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp27_ = where;
#line 1130 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (_tmp27_ == NULL) {
#line 1131 "../libdeja/tools/duplicity/DuplicityJob.vala"
								duplicity_job_show_error (self, _ ("No space left."), NULL);
#line 5824 "DuplicityJob.c"
							} else {
								const gchar* _tmp28_;
								gchar* _tmp29_;
								gchar* _tmp30_;
#line 1133 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp28_ = where;
#line 1133 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp29_ = g_strdup_printf (_ ("No space left in ‘%s’."), _tmp28_);
#line 1133 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp30_ = _tmp29_;
#line 1133 "../libdeja/tools/duplicity/DuplicityJob.vala"
								duplicity_job_show_error (self, _tmp30_, NULL);
#line 1133 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp30_);
#line 5839 "DuplicityJob.c"
							}
#line 1124 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_g_free0 (where);
#line 5843 "DuplicityJob.c"
						} else {
#line 1135 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (string_contains (text, "CRC check failed")) {
#line 1136 "../libdeja/tools/duplicity/DuplicityJob.vala"
								if (duplicity_job_restart_without_cache (self)) {
#line 1137 "../libdeja/tools/duplicity/DuplicityJob.vala"
									return;
#line 5851 "DuplicityJob.c"
								}
							}
						}
					}
				}
#line 1139 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5859 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("CollectionsError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5865 "DuplicityJob.c"
			default:
			{
#line 1141 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_show_error (self, _ ("No backup files found"), NULL);
#line 1142 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5872 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("AssertionError")))) {
#line 1091 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5878 "DuplicityJob.c"
			default:
			{
#line 1148 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart_without_cache (self)) {
#line 1149 "../libdeja/tools/duplicity/DuplicityJob.vala"
					return;
#line 5885 "DuplicityJob.c"
				}
#line 1150 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5889 "DuplicityJob.c"
			}
		}
	}
#line 1159 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp32_ = self->priv->_error_issued;
#line 1159 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (!_tmp32_) {
#line 1159 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp31_ = !duplicity_job_restart_without_cache (self);
#line 5899 "DuplicityJob.c"
	} else {
#line 1159 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp31_ = FALSE;
#line 5903 "DuplicityJob.c"
	}
#line 1159 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp31_) {
#line 1160 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), text);
#line 5909 "DuplicityJob.c"
	}
}

static void
duplicity_job_real_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 gint firstline_length1,
                                 GList* data,
                                 const gchar* text)
{
#line 1163 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1169 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 5924 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[1];
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp0_)) {
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_NEW:
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED:
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_DELETED:
#line 5936 "DuplicityJob.c"
			{
#line 1174 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 5940 "DuplicityJob.c"
					const gchar* _tmp1_;
#line 1175 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp1_ = firstline[2];
#line 1175 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_process_diff_file (self, _tmp1_);
#line 5946 "DuplicityJob.c"
				}
#line 1176 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5950 "DuplicityJob.c"
			}
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PATCH_FILE_WRITING:
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING:
#line 5956 "DuplicityJob.c"
			{
#line 1179 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 5960 "DuplicityJob.c"
					const gchar* _tmp2_;
#line 1180 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp2_ = firstline[2];
#line 1180 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_process_patch_file (self, _tmp2_);
#line 5966 "DuplicityJob.c"
				}
#line 1181 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5970 "DuplicityJob.c"
			}
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PROGRESS:
#line 5974 "DuplicityJob.c"
			{
#line 1183 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_progress (self, firstline, (gint) firstline_length1);
#line 1184 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5980 "DuplicityJob.c"
			}
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_COLLECTION_STATUS:
#line 5984 "DuplicityJob.c"
			{
#line 1186 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_collection_status (self, data);
#line 1187 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 5990 "DuplicityJob.c"
			}
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN:
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN:
#line 5996 "DuplicityJob.c"
			{
				DejaDupBackend* _tmp3_;
				DejaDupBackend* _tmp4_;
#line 1190 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1190 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp4_ = _tmp3_;
#line 1190 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (!deja_dup_backend_is_native (_tmp4_)) {
#line 1191 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_set_status (self, _ ("Uploading…"), TRUE);
#line 6008 "DuplicityJob.c"
				}
#line 1192 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 6012 "DuplicityJob.c"
			}
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_FILE_STAT:
#line 6016 "DuplicityJob.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 1194 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp5_ = firstline[2];
#line 1194 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp6_ = firstline[3];
#line 1194 "../libdeja/tools/duplicity/DuplicityJob.vala"
				duplicity_job_process_file_stat (self, _tmp5_, _tmp6_, data, text);
#line 1195 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 6028 "DuplicityJob.c"
			}
			default:
#line 1170 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 6033 "DuplicityJob.c"
		}
	}
}

void
duplicity_job_process_info (DuplicityJob* self,
                            gchar** firstline,
                            gint firstline_length1,
                            GList* data,
                            const gchar* text)
{
#line 1163 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1163 "../libdeja/tools/duplicity/DuplicityJob.vala"
	DUPLICITY_JOB_GET_CLASS (self)->process_info (self, firstline, firstline_length1, data, text);
#line 6049 "DuplicityJob.c"
}

static void
duplicity_job_process_file_stat (DuplicityJob* self,
                                 const gchar* date,
                                 const gchar* file,
                                 GList* data,
                                 const gchar* text)
{
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	DuplicityJobState _tmp2_;
#line 1200 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1200 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (date != NULL);
#line 1200 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1200 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1202 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1202 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 1202 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp1_ != DEJA_DUP_TOOL_JOB_MODE_LIST) {
#line 1203 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 6078 "DuplicityJob.c"
	}
#line 1204 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = self->priv->_state;
#line 1204 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ == DUPLICITY_JOB_STATE_CHECK_CONTENTS) {
#line 6084 "DuplicityJob.c"
		GFile* gfile = NULL;
		GFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GFile* _tmp5_;
		GFile* _tmp6_;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 1205 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = duplicity_job_make_file_obj (self, file);
#line 1205 "../libdeja/tools/duplicity/DuplicityJob.vala"
		gfile = _tmp3_;
#line 1206 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = gfile;
#line 1206 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp6_ = duplicity_job_slash_root;
#line 1206 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (g_file_equal (_tmp5_, _tmp6_)) {
#line 1206 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp4_ = TRUE;
#line 6105 "DuplicityJob.c"
		} else {
			gboolean _tmp7_ = FALSE;
			GFile* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp8_ = gfile;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp9_ = g_file_get_parent (_tmp8_);
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp10_ = _tmp9_;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp11_ = _tmp10_ != NULL;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_g_object_unref0 (_tmp10_);
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			if (_tmp11_) {
#line 6124 "DuplicityJob.c"
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp12_ = gfile;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp13_ = g_file_get_parent (_tmp12_);
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp14_ = _tmp13_;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp15_ = duplicity_job_slash_home;
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp7_ = g_file_equal (_tmp14_, _tmp15_);
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_object_unref0 (_tmp14_);
#line 6141 "DuplicityJob.c"
			} else {
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp7_ = FALSE;
#line 6145 "DuplicityJob.c"
			}
#line 1207 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp4_ = _tmp7_;
#line 6149 "DuplicityJob.c"
		}
#line 1206 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp4_) {
#line 6153 "DuplicityJob.c"
			GFile* _tmp16_;
			GFile* _tmp17_;
#line 1208 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp16_ = gfile;
#line 1208 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1208 "../libdeja/tools/duplicity/DuplicityJob.vala"
			self->priv->homes = g_list_append (self->priv->homes, _tmp17_);
#line 6162 "DuplicityJob.c"
		}
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (!self->priv->has_non_home_contents) {
#line 6166 "DuplicityJob.c"
			GFile* _tmp21_;
			GFile* _tmp22_;
#line 1210 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp21_ = gfile;
#line 1210 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp22_ = duplicity_job_slash;
#line 1210 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp20_ = !g_file_equal (_tmp21_, _tmp22_);
#line 6175 "DuplicityJob.c"
		} else {
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp20_ = FALSE;
#line 6179 "DuplicityJob.c"
		}
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp20_) {
#line 6183 "DuplicityJob.c"
			GFile* _tmp23_;
			GFile* _tmp24_;
#line 1211 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp23_ = gfile;
#line 1211 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp24_ = duplicity_job_slash_home;
#line 1211 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp19_ = !g_file_equal (_tmp23_, _tmp24_);
#line 6192 "DuplicityJob.c"
		} else {
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp19_ = FALSE;
#line 6196 "DuplicityJob.c"
		}
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp19_) {
#line 6200 "DuplicityJob.c"
			GFile* _tmp25_;
			GFile* _tmp26_;
#line 1212 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp25_ = gfile;
#line 1212 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp26_ = duplicity_job_slash_home;
#line 1212 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp18_ = !g_file_has_prefix (_tmp25_, _tmp26_);
#line 6209 "DuplicityJob.c"
		} else {
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp18_ = FALSE;
#line 6213 "DuplicityJob.c"
		}
#line 1209 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp18_) {
#line 1213 "../libdeja/tools/duplicity/DuplicityJob.vala"
			self->priv->has_non_home_contents = TRUE;
#line 6219 "DuplicityJob.c"
		}
#line 1204 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (gfile);
#line 6223 "DuplicityJob.c"
	}
#line 1215 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "listed-current-files", date, file);
#line 6227 "DuplicityJob.c"
}

static void
duplicity_job_process_diff_file (DuplicityJob* self,
                                 const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1218 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1218 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1219 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_make_file_obj (self, file);
#line 1219 "../libdeja/tools/duplicity/DuplicityJob.vala"
	gfile = _tmp0_;
#line 1220 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = gfile;
#line 1220 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1220 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 1220 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = _tmp2_;
#line 1221 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = gfile;
#line 1221 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 6259 "DuplicityJob.c"
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
#line 1222 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = gfile;
#line 1222 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->_state;
#line 1222 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
#line 6268 "DuplicityJob.c"
	}
#line 1218 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (gfile);
#line 6272 "DuplicityJob.c"
}

static void
duplicity_job_process_patch_file (DuplicityJob* self,
                                  const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1225 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1225 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1226 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_make_file_obj (self, file);
#line 1226 "../libdeja/tools/duplicity/DuplicityJob.vala"
	gfile = _tmp0_;
#line 1227 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = gfile;
#line 1227 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1227 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 1227 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = _tmp2_;
#line 1228 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp3_ = gfile;
#line 1228 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 6304 "DuplicityJob.c"
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
#line 1229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = gfile;
#line 1229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->_state;
#line 1229 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
#line 6313 "DuplicityJob.c"
	}
#line 1225 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (gfile);
#line 6317 "DuplicityJob.c"
}

static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	return result;
#line 6330 "DuplicityJob.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 6343 "DuplicityJob.c"
}

static void
duplicity_job_process_progress (DuplicityJob* self,
                                gchar** firstline,
                                gint firstline_length1)
{
	gdouble total = 0.0;
	gdouble percent = 0.0;
#line 1232 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1236 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 2) {
#line 6357 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1237 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[2];
#line 1237 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->progress_count = uint64_parse (_tmp0_);
#line 6363 "DuplicityJob.c"
	} else {
#line 1239 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 6367 "DuplicityJob.c"
	}
#line 1241 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 3) {
#line 6371 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 1242 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = firstline[3];
#line 1242 "../libdeja/tools/duplicity/DuplicityJob.vala"
		total = double_parse (_tmp1_);
#line 6377 "DuplicityJob.c"
	} else {
#line 1243 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (self->priv->progress_total > ((guint64) 0)) {
#line 1244 "../libdeja/tools/duplicity/DuplicityJob.vala"
			total = (gdouble) self->priv->progress_total;
#line 6383 "DuplicityJob.c"
		} else {
#line 1246 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return;
#line 6387 "DuplicityJob.c"
		}
	}
#line 1248 "../libdeja/tools/duplicity/DuplicityJob.vala"
	percent = ((gdouble) self->priv->progress_count) / total;
#line 1249 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (percent > ((gdouble) 1)) {
#line 1250 "../libdeja/tools/duplicity/DuplicityJob.vala"
		percent = (gdouble) 1;
#line 6396 "DuplicityJob.c"
	}
#line 1251 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (percent < ((gdouble) 0)) {
#line 1252 "../libdeja/tools/duplicity/DuplicityJob.vala"
		percent = (gdouble) 0;
#line 6402 "DuplicityJob.c"
	}
#line 1253 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", percent);
#line 6406 "DuplicityJob.c"
}

static GFile*
duplicity_job_make_file_obj (DuplicityJob* self,
                             const gchar* file)
{
	GFile* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 1256 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1256 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1259 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_slash;
#line 1259 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = g_file_resolve_relative_path (_tmp0_, file);
#line 1259 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp1_;
#line 1259 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 6428 "DuplicityJob.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 6452 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 6460 "DuplicityJob.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 6466 "DuplicityJob.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 6484 "DuplicityJob.c"
}

static gpointer
_duplicity_job_date_info_dup0 (gpointer self)
{
#line 1294 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return self ? duplicity_job_date_info_dup (self) : NULL;
#line 6492 "DuplicityJob.c"
}

static void
duplicity_job_process_collection_status (DuplicityJob* self,
                                         GList* lines)
{
	gboolean _tmp0_ = FALSE;
	DejaDupToolJobMode _tmp1_;
	DejaDupToolJobMode _tmp2_;
	GTimeVal timeval = {0};
	GList* dates = NULL;
	GList* infos = NULL;
	gboolean in_chain = FALSE;
	GList* _tmp32_;
	GList* _tmp35_;
#line 1262 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = _tmp1_;
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ != DEJA_DUP_TOOL_JOB_MODE_STATUS) {
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = TRUE;
#line 6518 "DuplicityJob.c"
	} else {
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = self->priv->got_collection_info;
#line 6522 "DuplicityJob.c"
	}
#line 1272 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 1273 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return;
#line 6528 "DuplicityJob.c"
	}
#line 1275 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_get_current_time (&timeval);
#line 1276 "../libdeja/tools/duplicity/DuplicityJob.vala"
	dates = NULL;
#line 1277 "../libdeja/tools/duplicity/DuplicityJob.vala"
	infos = NULL;
#line 1278 "../libdeja/tools/duplicity/DuplicityJob.vala"
	in_chain = FALSE;
#line 6538 "DuplicityJob.c"
	{
		GList* line_collection = NULL;
		GList* line_it = NULL;
#line 1279 "../libdeja/tools/duplicity/DuplicityJob.vala"
		line_collection = lines;
#line 1279 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (line_it = line_collection; line_it != NULL; line_it = line_it->next) {
#line 6546 "DuplicityJob.c"
			gchar* _tmp3_;
			gchar* line = NULL;
#line 1279 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp3_ = g_strdup ((const gchar*) line_it->data);
#line 1279 "../libdeja/tools/duplicity/DuplicityJob.vala"
			line = _tmp3_;
#line 6553 "DuplicityJob.c"
			{
				gboolean _tmp4_ = FALSE;
				const gchar* _tmp5_;
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp5_ = line;
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (g_strcmp0 (_tmp5_, "chain-complete") == 0) {
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp4_ = TRUE;
#line 6563 "DuplicityJob.c"
				} else {
					const gchar* _tmp6_;
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = line;
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp4_ = string_index_of (_tmp6_, "chain-no-sig", 0) == 0;
#line 6570 "DuplicityJob.c"
				}
#line 1280 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp4_) {
#line 1281 "../libdeja/tools/duplicity/DuplicityJob.vala"
					in_chain = TRUE;
#line 6576 "DuplicityJob.c"
				} else {
					gboolean _tmp7_ = FALSE;
					gboolean _tmp8_ = FALSE;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (in_chain) {
#line 6582 "DuplicityJob.c"
						const gchar* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp9_ = line;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp10_ = strlen (_tmp9_);
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp11_ = _tmp10_;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp8_ = _tmp11_ > 0;
#line 6594 "DuplicityJob.c"
					} else {
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp8_ = FALSE;
#line 6598 "DuplicityJob.c"
					}
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp8_) {
#line 6602 "DuplicityJob.c"
						const gchar* _tmp12_;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp12_ = line;
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp7_ = string_get (_tmp12_, (glong) 0) == ' ';
#line 6608 "DuplicityJob.c"
					} else {
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp7_ = FALSE;
#line 6612 "DuplicityJob.c"
					}
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp7_) {
#line 6616 "DuplicityJob.c"
						gchar** tokens = NULL;
						const gchar* _tmp13_;
						gchar** _tmp14_;
						gchar** _tmp15_;
						gint tokens_length1;
						gint _tokens_size_;
						gboolean _tmp16_ = FALSE;
						gchar** _tmp17_;
						gint _tmp17__length1;
#line 1287 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp13_ = line;
#line 1287 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, " ", 0);
#line 1287 "../libdeja/tools/duplicity/DuplicityJob.vala"
						tokens = _tmp15_;
#line 1287 "../libdeja/tools/duplicity/DuplicityJob.vala"
						tokens_length1 = _vala_array_length (_tmp14_);
#line 1287 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tokens_size_ = tokens_length1;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp17_ = tokens;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp17__length1 = tokens_length1;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp17__length1 > 2) {
#line 6642 "DuplicityJob.c"
							gchar** _tmp18_;
							gint _tmp18__length1;
							const gchar* _tmp19_;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp18_ = tokens;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp18__length1 = tokens_length1;
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp19_ = _tmp18_[2];
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp16_ = g_time_val_from_iso8601 (_tmp19_, &timeval);
#line 6654 "DuplicityJob.c"
						} else {
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp16_ = FALSE;
#line 6658 "DuplicityJob.c"
						}
#line 1288 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (_tmp16_) {
#line 6662 "DuplicityJob.c"
							gchar** _tmp20_;
							gint _tmp20__length1;
							const gchar* _tmp21_;
							gchar* _tmp22_;
							DuplicityJobDateInfo info = {0};
							GTimeVal _tmp23_;
							gchar** _tmp24_;
							gint _tmp24__length1;
							const gchar* _tmp25_;
							DuplicityJobDateInfo _tmp26_;
							DuplicityJobDateInfo* _tmp27_;
							gboolean _tmp28_ = FALSE;
#line 1289 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp20_ = tokens;
#line 1289 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp20__length1 = tokens_length1;
#line 1289 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp21_ = _tmp20_[2];
#line 1289 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp22_ = g_strdup (_tmp21_);
#line 1289 "../libdeja/tools/duplicity/DuplicityJob.vala"
							dates = g_list_append (dates, _tmp22_);
#line 1291 "../libdeja/tools/duplicity/DuplicityJob.vala"
							memset (&info, 0, sizeof (DuplicityJobDateInfo));
#line 1292 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp23_ = timeval;
#line 1292 "../libdeja/tools/duplicity/DuplicityJob.vala"
							info.time = _tmp23_;
#line 1293 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp24_ = tokens;
#line 1293 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp24__length1 = tokens_length1;
#line 1293 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp25_ = _tmp24_[1];
#line 1293 "../libdeja/tools/duplicity/DuplicityJob.vala"
							info.full = g_strcmp0 (_tmp25_, "full") == 0;
#line 1294 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp26_ = info;
#line 1294 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp27_ = _duplicity_job_date_info_dup0 (&_tmp26_);
#line 1294 "../libdeja/tools/duplicity/DuplicityJob.vala"
							infos = g_list_append (infos, _tmp27_);
#line 1296 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (!self->priv->detected_encryption) {
#line 6707 "DuplicityJob.c"
								gchar** _tmp29_;
								gint _tmp29__length1;
#line 1297 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp29_ = tokens;
#line 1297 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp29__length1 = tokens_length1;
#line 1297 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp28_ = _tmp29__length1 > 4;
#line 6716 "DuplicityJob.c"
							} else {
#line 1296 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp28_ = FALSE;
#line 6720 "DuplicityJob.c"
							}
#line 1296 "../libdeja/tools/duplicity/DuplicityJob.vala"
							if (_tmp28_) {
#line 6724 "DuplicityJob.c"
								gchar** _tmp30_;
								gint _tmp30__length1;
								const gchar* _tmp31_;
#line 1300 "../libdeja/tools/duplicity/DuplicityJob.vala"
								self->priv->detected_encryption = TRUE;
#line 1301 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp30_ = tokens;
#line 1301 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp30__length1 = tokens_length1;
#line 1301 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp31_ = _tmp30_[4];
#line 1301 "../libdeja/tools/duplicity/DuplicityJob.vala"
								self->priv->existing_encrypted = g_strcmp0 (_tmp31_, "enc") == 0;
#line 6738 "DuplicityJob.c"
							}
						}
#line 1282 "../libdeja/tools/duplicity/DuplicityJob.vala"
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 6743 "DuplicityJob.c"
					} else {
#line 1305 "../libdeja/tools/duplicity/DuplicityJob.vala"
						if (in_chain) {
#line 1306 "../libdeja/tools/duplicity/DuplicityJob.vala"
							in_chain = FALSE;
#line 6749 "DuplicityJob.c"
						}
					}
				}
#line 1279 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (line);
#line 6755 "DuplicityJob.c"
			}
		}
	}
#line 1309 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->got_collection_info = TRUE;
#line 1310 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
#line 1310 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->collection_info = NULL;
#line 1311 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp32_ = infos;
#line 6767 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1311 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = _tmp32_;
#line 1311 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 6775 "DuplicityJob.c"
			DuplicityJobDateInfo s = {0};
#line 1311 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = *((DuplicityJobDateInfo*) s_it->data);
#line 6779 "DuplicityJob.c"
			{
				DuplicityJobDateInfo _tmp33_;
				DuplicityJobDateInfo* _tmp34_;
#line 1312 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp33_ = s;
#line 1312 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp34_ = _duplicity_job_date_info_dup0 (&_tmp33_);
#line 1312 "../libdeja/tools/duplicity/DuplicityJob.vala"
				self->priv->collection_info = g_list_append (self->priv->collection_info, _tmp34_);
#line 6789 "DuplicityJob.c"
			}
		}
	}
#line 1314 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp35_ = dates;
#line 1314 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "collection-dates", _tmp35_);
#line 1262 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(infos == NULL) ? NULL : (infos = (_g_list_free__duplicity_job_date_info_free0_ (infos), NULL));
#line 1262 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(dates == NULL) ? NULL : (dates = (_g_list_free__g_free0_ (dates), NULL));
#line 6801 "DuplicityJob.c"
}

static void
duplicity_job_real_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    gint firstline_length1,
                                    GList* data,
                                    const gchar* text)
{
#line 1317 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1320 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 6815 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[1];
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp0_)) {
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_ORPHANED_SIG:
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_UNNECESSARY_SIG:
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_UNMATCHED_SIG:
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP:
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_ORPHANED_BACKUP:
#line 6831 "DuplicityJob.c"
			{
				gboolean _tmp1_ = FALSE;
				DejaDupToolJobMode _tmp2_;
				DejaDupToolJobMode _tmp3_;
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp3_ = _tmp2_;
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp1_ = !self->priv->cleaned_up_once;
#line 6844 "DuplicityJob.c"
				} else {
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp1_ = FALSE;
#line 6848 "DuplicityJob.c"
				}
#line 1331 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp1_) {
#line 1332 "../libdeja/tools/duplicity/DuplicityJob.vala"
					duplicity_job_cleanup (self);
#line 6854 "DuplicityJob.c"
				}
#line 1333 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 6858 "DuplicityJob.c"
			}
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_CANNOT_READ:
#line 6862 "DuplicityJob.c"
			{
#line 1338 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 6866 "DuplicityJob.c"
					GFile* error_file = NULL;
					const gchar* _tmp4_;
					GFile* _tmp5_;
					GList* _tmp6_;
#line 1342 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp4_ = firstline[2];
#line 1342 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp5_ = duplicity_job_make_file_obj (self, _tmp4_);
#line 1342 "../libdeja/tools/duplicity/DuplicityJob.vala"
					error_file = _tmp5_;
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp6_ = ((DejaDupToolJob*) self)->includes;
#line 6879 "DuplicityJob.c"
					{
						GList* f_collection = NULL;
						GList* f_it = NULL;
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
						f_collection = _tmp6_;
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
						for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 6887 "DuplicityJob.c"
							GFile* _tmp7_;
							GFile* f = NULL;
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
							_tmp7_ = _g_object_ref0 ((GFile*) f_it->data);
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
							f = _tmp7_;
#line 6894 "DuplicityJob.c"
							{
								gboolean _tmp8_ = FALSE;
								GFile* _tmp9_;
								GFile* _tmp10_;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp9_ = error_file;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_tmp10_ = f;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
								if (g_file_equal (_tmp9_, _tmp10_)) {
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp8_ = TRUE;
#line 6907 "DuplicityJob.c"
								} else {
									GFile* _tmp11_;
									GFile* _tmp12_;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp11_ = error_file;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp12_ = f;
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp8_ = g_file_has_prefix (_tmp11_, _tmp12_);
#line 6917 "DuplicityJob.c"
								}
#line 1344 "../libdeja/tools/duplicity/DuplicityJob.vala"
								if (_tmp8_) {
#line 6921 "DuplicityJob.c"
									GFile* _tmp13_;
									GFile* _tmp14_;
#line 1345 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp13_ = error_file;
#line 1345 "../libdeja/tools/duplicity/DuplicityJob.vala"
									_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1345 "../libdeja/tools/duplicity/DuplicityJob.vala"
									self->priv->local_error_files = g_list_append (self->priv->local_error_files, _tmp14_);
#line 6930 "DuplicityJob.c"
								}
#line 1343 "../libdeja/tools/duplicity/DuplicityJob.vala"
								_g_object_unref0 (f);
#line 6934 "DuplicityJob.c"
							}
						}
					}
#line 1338 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (error_file);
#line 6940 "DuplicityJob.c"
				}
#line 1348 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 6944 "DuplicityJob.c"
			}
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_CANNOT_PROCESS:
#line 6948 "DuplicityJob.c"
			{
#line 1353 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 6952 "DuplicityJob.c"
					GFile* error_file = NULL;
					const gchar* _tmp15_;
					GFile* _tmp16_;
					gboolean _tmp17_ = FALSE;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 1357 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp15_ = firstline[2];
#line 1357 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp16_ = duplicity_job_make_file_obj (self, _tmp15_);
#line 1357 "../libdeja/tools/duplicity/DuplicityJob.vala"
					error_file = _tmp16_;
#line 1358 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp18_ = error_file;
#line 1358 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp19_ = duplicity_job_slash;
#line 1358 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (!g_file_equal (_tmp18_, _tmp19_)) {
#line 1359 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp17_ = !string_contains (text, "[Errno 1]");
#line 6973 "DuplicityJob.c"
					} else {
#line 1358 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp17_ = FALSE;
#line 6977 "DuplicityJob.c"
					}
#line 1358 "../libdeja/tools/duplicity/DuplicityJob.vala"
					if (_tmp17_) {
#line 6981 "DuplicityJob.c"
						GFile* _tmp20_;
						GFile* _tmp21_;
#line 1360 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp20_ = error_file;
#line 1360 "../libdeja/tools/duplicity/DuplicityJob.vala"
						_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1360 "../libdeja/tools/duplicity/DuplicityJob.vala"
						self->priv->local_error_files = g_list_append (self->priv->local_error_files, _tmp21_);
#line 6990 "DuplicityJob.c"
					}
#line 1353 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_g_object_unref0 (error_file);
#line 6994 "DuplicityJob.c"
				}
#line 1362 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 6998 "DuplicityJob.c"
			}
			default:
#line 1321 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 7003 "DuplicityJob.c"
		}
	}
}

void
duplicity_job_process_warning (DuplicityJob* self,
                               gchar** firstline,
                               gint firstline_length1,
                               GList* data,
                               const gchar* text)
{
#line 1317 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1317 "../libdeja/tools/duplicity/DuplicityJob.vala"
	DUPLICITY_JOB_GET_CLASS (self)->process_warning (self, firstline, firstline_length1, data, text);
#line 7019 "DuplicityJob.c"
}

static void
duplicity_job_show_error (DuplicityJob* self,
                          const gchar* errorstr,
                          const gchar* detail)
{
	gboolean _tmp0_;
#line 1367 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1367 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (errorstr != NULL);
#line 1369 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_error_issued;
#line 1369 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ == FALSE) {
#line 1370 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_error_issued (self, TRUE);
#line 1371 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) self, "raise-error", errorstr, detail);
#line 7040 "DuplicityJob.c"
	}
}

static gint
duplicity_job_get_volsize (DuplicityJob* self)
{
	gint result = 0;
#line 1376 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1395 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (deja_dup_in_testing_mode ()) {
#line 1396 "../libdeja/tools/duplicity/DuplicityJob.vala"
		result = 1;
#line 1396 "../libdeja/tools/duplicity/DuplicityJob.vala"
		return result;
#line 7056 "DuplicityJob.c"
	} else {
		DejaDupBackend* _tmp0_;
		DejaDupBackend* _tmp1_;
#line 1397 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1397 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = _tmp0_;
#line 1397 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (deja_dup_backend_is_native (_tmp1_)) {
#line 1398 "../libdeja/tools/duplicity/DuplicityJob.vala"
			result = 50;
#line 1398 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return result;
#line 7070 "DuplicityJob.c"
		} else {
#line 1400 "../libdeja/tools/duplicity/DuplicityJob.vala"
			result = 25;
#line 1400 "../libdeja/tools/duplicity/DuplicityJob.vala"
			return result;
#line 7076 "DuplicityJob.c"
		}
	}
}

static void
_duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                    gboolean success,
                                                    gboolean cancelled,
                                                    gpointer self)
{
#line 1407 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_handle_done ((DuplicityJob*) self, _sender, success, cancelled);
#line 7089 "DuplicityJob.c"
}

static void
_duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                          gchar** control_line,
                                                          gint control_line_length1,
                                                          GList* data_lines,
                                                          const gchar* user_text,
                                                          gpointer self)
{
#line 1408 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_handle_message ((DuplicityJob*) self, _sender, control_line, control_line_length1, data_lines, user_text);
#line 7102 "DuplicityJob.c"
}

static void
_duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                      gint code,
                                                      gpointer self)
{
#line 1409 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_handle_exit ((DuplicityJob*) self, code);
#line 7112 "DuplicityJob.c"
}

static void
duplicity_job_disconnect_inst (DuplicityJob* self)
{
	DuplicityInstance* _tmp0_;
#line 1403 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1406 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 1406 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 7125 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
		guint _tmp2_;
		DuplicityInstance* _tmp3_;
		guint _tmp4_;
		DuplicityInstance* _tmp5_;
		guint _tmp6_;
		DuplicityInstance* _tmp7_;
#line 1407 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 1407 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("done", TYPE_DUPLICITY_INSTANCE, &_tmp2_, NULL, FALSE);
#line 1407 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self);
#line 1408 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = self->priv->inst;
#line 1408 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("message", TYPE_DUPLICITY_INSTANCE, &_tmp4_, NULL, FALSE);
#line 1408 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self);
#line 1409 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->inst;
#line 1409 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("exited", TYPE_DUPLICITY_INSTANCE, &_tmp6_, NULL, FALSE);
#line 1409 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self);
#line 1410 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp7_ = self->priv->inst;
#line 1410 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_instance_cancel (_tmp7_);
#line 1411 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->inst);
#line 1411 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->inst = NULL;
#line 7159 "DuplicityJob.c"
	}
}

static void
duplicity_job_connect_and_start (DuplicityJob* self,
                                 GList* argv_extra,
                                 GList* envp_extra,
                                 GList* argv_entire,
                                 GFile* custom_local)
{
	DuplicityInstance* _tmp0_;
	DuplicityInstance* _tmp1_;
	const gchar* _tmp2_;
	DuplicityInstance* _tmp5_;
	DuplicityInstance* _tmp6_;
	GList* _tmp7_ = NULL;
	GList* master_argv = NULL;
	GFile* _tmp9_ = NULL;
	GFile* local_arg = NULL;
	GList* argv = NULL;
	GList* _tmp12_;
	GList* _tmp16_;
	GList* envp = NULL;
	GList* _tmp49_;
	gboolean use_encryption = FALSE;
	DuplicityInstance* _tmp70_;
	GList* _tmp71_;
	GList* _tmp72_;
#line 1415 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1424 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 1427 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_instance_new ();
#line 1427 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->inst);
#line 1427 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->inst = _tmp0_;
#line 1428 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = self->priv->inst;
#line 1428 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp1_, "done", (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self, 0);
#line 1430 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp2_ = self->priv->forced_cache_dir;
#line 1430 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp2_ != NULL) {
#line 7206 "DuplicityJob.c"
		DuplicityInstance* _tmp3_;
		const gchar* _tmp4_;
#line 1431 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = self->priv->inst;
#line 1431 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = self->priv->forced_cache_dir;
#line 1431 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_instance_set_forced_cache_dir (_tmp3_, _tmp4_);
#line 7215 "DuplicityJob.c"
	}
#line 1434 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp5_ = self->priv->inst;
#line 1434 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp5_, "message", (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self, 0);
#line 1437 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp6_ = self->priv->inst;
#line 1437 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp6_, "exited", (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self, 0);
#line 1440 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (argv_entire == NULL) {
#line 7227 "DuplicityJob.c"
		GList* _tmp8_;
#line 1440 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp8_ = self->priv->saved_argv;
#line 1440 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp7_ = _tmp8_;
#line 7233 "DuplicityJob.c"
	} else {
#line 1440 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp7_ = argv_entire;
#line 7237 "DuplicityJob.c"
	}
#line 1440 "../libdeja/tools/duplicity/DuplicityJob.vala"
	master_argv = _tmp7_;
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (custom_local == NULL) {
#line 7243 "DuplicityJob.c"
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp10_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp11_ = _tmp10_;
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp9_ = _tmp11_;
#line 7252 "DuplicityJob.c"
	} else {
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp9_ = custom_local;
#line 7256 "DuplicityJob.c"
	}
#line 1441 "../libdeja/tools/duplicity/DuplicityJob.vala"
	local_arg = _tmp9_;
#line 1443 "../libdeja/tools/duplicity/DuplicityJob.vala"
	argv = NULL;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp12_ = master_argv;
#line 7264 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = _tmp12_;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7272 "DuplicityJob.c"
			gchar* _tmp13_;
			gchar* s = NULL;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp13_ = g_strdup ((const gchar*) s_it->data);
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp13_;
#line 7279 "DuplicityJob.c"
			{
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp14_ = s;
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp15_);
#line 1444 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7291 "DuplicityJob.c"
			}
		}
	}
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp16_ = self->priv->backend_argv;
#line 7297 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = _tmp16_;
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7305 "DuplicityJob.c"
			gchar* _tmp17_;
			gchar* s = NULL;
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp17_ = g_strdup ((const gchar*) s_it->data);
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp17_;
#line 7312 "DuplicityJob.c"
			{
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp18_ = s;
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp19_);
#line 1445 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7324 "DuplicityJob.c"
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = argv_extra;
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7335 "DuplicityJob.c"
			gchar* _tmp20_;
			gchar* s = NULL;
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp20_ = g_strdup ((const gchar*) s_it->data);
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp20_;
#line 7342 "DuplicityJob.c"
			{
				const gchar* _tmp21_;
				gchar* _tmp22_;
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp21_ = s;
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp22_);
#line 1446 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7354 "DuplicityJob.c"
			}
		}
	}
#line 1449 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (argv_entire == NULL) {
#line 7360 "DuplicityJob.c"
		DejaDupToolJobMode _tmp23_;
		DejaDupToolJobMode _tmp24_;
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp23_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp24_ = _tmp23_;
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
		switch (_tmp24_) {
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
#line 7371 "DuplicityJob.c"
			{
				gchar* _tmp26_;
				GFile* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1453 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (self->priv->is_full_backup) {
#line 7379 "DuplicityJob.c"
					gchar* _tmp25_;
#line 1454 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp25_ = g_strdup ("full");
#line 1454 "../libdeja/tools/duplicity/DuplicityJob.vala"
					argv = g_list_prepend (argv, _tmp25_);
#line 7385 "DuplicityJob.c"
				}
#line 1455 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp26_ = g_strdup_printf ("--volsize=%d", duplicity_job_get_volsize (self));
#line 1455 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp26_);
#line 1456 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp27_ = local_arg;
#line 1456 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp28_ = g_file_get_path (_tmp27_);
#line 1456 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp28_);
#line 1457 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp29_ = duplicity_job_get_remote (self, NULL);
#line 1457 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp29_);
#line 1458 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 7403 "DuplicityJob.c"
			}
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
#line 7407 "DuplicityJob.c"
			{
				gchar* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				GFile* _tmp38_;
				gchar* _tmp39_;
#line 1460 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp30_ = g_strdup ("restore");
#line 1460 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp30_);
#line 1461 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp31_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
#line 1461 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp32_ = _tmp31_;
#line 1461 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp32_ != NULL) {
#line 7426 "DuplicityJob.c"
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
#line 1462 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp33_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
#line 1462 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp34_ = _tmp33_;
#line 1462 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp35_ = g_strdup_printf ("--time=%s", _tmp34_);
#line 1462 "../libdeja/tools/duplicity/DuplicityJob.vala"
					argv = g_list_append (argv, _tmp35_);
#line 7438 "DuplicityJob.c"
				}
#line 1463 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp36_ = g_strdup ("--force");
#line 1463 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp36_);
#line 1464 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp37_ = duplicity_job_get_remote (self, NULL);
#line 1464 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp37_);
#line 1465 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp38_ = local_arg;
#line 1465 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp39_ = g_file_get_path (_tmp38_);
#line 1465 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp39_);
#line 1466 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 7456 "DuplicityJob.c"
			}
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_STATUS:
#line 7460 "DuplicityJob.c"
			{
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 1468 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp40_ = g_strdup ("collection-status");
#line 1468 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp40_);
#line 1469 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp41_ = duplicity_job_get_remote (self, NULL);
#line 1469 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp41_);
#line 1470 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 7474 "DuplicityJob.c"
			}
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_LIST:
#line 7478 "DuplicityJob.c"
			{
				gchar* _tmp42_;
				const gchar* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp48_;
#line 1472 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp42_ = g_strdup ("list-current-files");
#line 1472 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp42_);
#line 1473 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp43_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
#line 1473 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp44_ = _tmp43_;
#line 1473 "../libdeja/tools/duplicity/DuplicityJob.vala"
				if (_tmp44_ != NULL) {
#line 7494 "DuplicityJob.c"
					const gchar* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
#line 1474 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp45_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
#line 1474 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp46_ = _tmp45_;
#line 1474 "../libdeja/tools/duplicity/DuplicityJob.vala"
					_tmp47_ = g_strdup_printf ("--time=%s", _tmp46_);
#line 1474 "../libdeja/tools/duplicity/DuplicityJob.vala"
					argv = g_list_append (argv, _tmp47_);
#line 7506 "DuplicityJob.c"
				}
#line 1475 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp48_ = duplicity_job_get_remote (self, NULL);
#line 1475 "../libdeja/tools/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp48_);
#line 1476 "../libdeja/tools/duplicity/DuplicityJob.vala"
				break;
#line 7514 "DuplicityJob.c"
			}
			default:
#line 1451 "../libdeja/tools/duplicity/DuplicityJob.vala"
			break;
#line 7519 "DuplicityJob.c"
		}
	}
#line 1481 "../libdeja/tools/duplicity/DuplicityJob.vala"
	envp = NULL;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp49_ = self->priv->saved_envp;
#line 7526 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = _tmp49_;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7534 "DuplicityJob.c"
			gchar* _tmp50_;
			gchar* s = NULL;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp50_ = g_strdup ((const gchar*) s_it->data);
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp50_;
#line 7541 "DuplicityJob.c"
			{
				const gchar* _tmp51_;
				gchar* _tmp52_;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp51_ = s;
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp52_ = g_strdup (_tmp51_);
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
				envp = g_list_append (envp, _tmp52_);
#line 1482 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7553 "DuplicityJob.c"
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
		s_collection = envp_extra;
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7564 "DuplicityJob.c"
			gchar* _tmp53_;
			gchar* s = NULL;
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp53_ = g_strdup ((const gchar*) s_it->data);
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
			s = _tmp53_;
#line 7571 "DuplicityJob.c"
			{
				const gchar* _tmp54_;
				gchar* _tmp55_;
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp54_ = s;
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_tmp55_ = g_strdup (_tmp54_);
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
				envp = g_list_append (envp, _tmp55_);
#line 1483 "../libdeja/tools/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7583 "DuplicityJob.c"
			}
		}
	}
#line 1485 "../libdeja/tools/duplicity/DuplicityJob.vala"
	use_encryption = FALSE;
#line 1486 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (self->priv->detected_encryption) {
#line 1487 "../libdeja/tools/duplicity/DuplicityJob.vala"
		use_encryption = self->priv->existing_encrypted;
#line 7593 "DuplicityJob.c"
	} else {
		const gchar* _tmp56_;
		const gchar* _tmp57_;
#line 1488 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp56_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1488 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp57_ = _tmp56_;
#line 1488 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp57_ != NULL) {
#line 7603 "DuplicityJob.c"
			const gchar* _tmp58_;
			const gchar* _tmp59_;
#line 1489 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp58_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1489 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp59_ = _tmp58_;
#line 1489 "../libdeja/tools/duplicity/DuplicityJob.vala"
			use_encryption = g_strcmp0 (_tmp59_, "") != 0;
#line 7612 "DuplicityJob.c"
		}
	}
#line 1491 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (use_encryption) {
#line 7617 "DuplicityJob.c"
		gboolean _tmp60_ = FALSE;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp61_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp62_ = _tmp61_;
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp62_ != NULL) {
#line 7627 "DuplicityJob.c"
			const gchar* _tmp63_;
			const gchar* _tmp64_;
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp63_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp64_ = _tmp63_;
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp60_ = g_strcmp0 (_tmp64_, "") != 0;
#line 7636 "DuplicityJob.c"
		} else {
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp60_ = FALSE;
#line 7640 "DuplicityJob.c"
		}
#line 1492 "../libdeja/tools/duplicity/DuplicityJob.vala"
		if (_tmp60_) {
#line 7644 "DuplicityJob.c"
			const gchar* _tmp65_;
			const gchar* _tmp66_;
			gchar* _tmp67_;
#line 1493 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp65_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1493 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp66_ = _tmp65_;
#line 1493 "../libdeja/tools/duplicity/DuplicityJob.vala"
			_tmp67_ = g_strdup_printf ("PASSPHRASE=%s", _tmp66_);
#line 1493 "../libdeja/tools/duplicity/DuplicityJob.vala"
			envp = g_list_append (envp, _tmp67_);
#line 7656 "DuplicityJob.c"
		}
	} else {
		gchar* _tmp68_;
		gchar* _tmp69_;
#line 1500 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp68_ = g_strdup ("--no-encryption");
#line 1500 "../libdeja/tools/duplicity/DuplicityJob.vala"
		argv = g_list_append (argv, _tmp68_);
#line 1501 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp69_ = g_strdup ("PASSPHRASE=");
#line 1501 "../libdeja/tools/duplicity/DuplicityJob.vala"
		envp = g_list_append (envp, _tmp69_);
#line 7669 "DuplicityJob.c"
	}
#line 1505 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp70_ = self->priv->inst;
#line 1505 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp71_ = argv;
#line 1505 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp72_ = envp;
#line 1505 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_instance_start (_tmp70_, _tmp71_, _tmp72_, self->priv->needs_root, NULL, NULL);
#line 1415 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(envp == NULL) ? NULL : (envp = (_g_list_free__g_free0_ (envp), NULL));
#line 1415 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
#line 7683 "DuplicityJob.c"
}

DuplicityJob*
duplicity_job_construct (GType object_type)
{
	DuplicityJob * self = NULL;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) deja_dup_tool_job_construct (object_type);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return self;
#line 7694 "DuplicityJob.c"
}

DuplicityJob*
duplicity_job_new (void)
{
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return duplicity_job_construct (TYPE_DUPLICITY_JOB);
#line 7702 "DuplicityJob.c"
}

static DejaDupToolJobMode
duplicity_job_get_original_mode (DuplicityJob* self)
{
	DejaDupToolJobMode result;
	DejaDupToolJobMode _tmp0_;
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_original_mode;
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp0_;
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 7718 "DuplicityJob.c"
}

static void
duplicity_job_set_original_mode (DuplicityJob* self,
                                 DejaDupToolJobMode value)
{
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 33 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->_original_mode = value;
#line 7729 "DuplicityJob.c"
}

static gboolean
duplicity_job_get_error_issued (DuplicityJob* self)
{
	gboolean result;
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = self->priv->_error_issued;
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 7742 "DuplicityJob.c"
}

static void
duplicity_job_set_error_issued (DuplicityJob* self,
                                gboolean value)
{
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->_error_issued = value;
#line 7753 "DuplicityJob.c"
}

static gboolean
duplicity_job_get_was_stopped (DuplicityJob* self)
{
	gboolean result;
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = self->priv->_was_stopped;
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 7766 "DuplicityJob.c"
}

static void
duplicity_job_set_was_stopped (DuplicityJob* self,
                               gboolean value)
{
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->_was_stopped = value;
#line 7777 "DuplicityJob.c"
}

DuplicityJobState
duplicity_job_get_state (DuplicityJob* self)
{
	DuplicityJobState result;
	DuplicityJobState _tmp0_;
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_state;
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	result = _tmp0_;
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return result;
#line 7793 "DuplicityJob.c"
}

void
duplicity_job_set_state (DuplicityJob* self,
                         DuplicityJobState value)
{
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (duplicity_job_get_state (self) != value) {
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
		self->priv->_state = value;
#line 46 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_object_notify_by_pspec ((GObject *) self, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY]);
#line 7808 "DuplicityJob.c"
	}
}

static GObject *
duplicity_job_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DuplicityJob * self;
	GFile* _tmp0_;
#line 104 "../libdeja/tools/duplicity/DuplicityJob.vala"
	parent_class = G_OBJECT_CLASS (duplicity_job_parent_class);
#line 104 "../libdeja/tools/duplicity/DuplicityJob.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 104 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 105 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_slash;
#line 105 "../libdeja/tools/duplicity/DuplicityJob.vala"
	if (_tmp0_ == NULL) {
#line 7831 "DuplicityJob.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
#line 106 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp1_ = g_file_new_for_path ("/");
#line 106 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (duplicity_job_slash);
#line 106 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_slash = _tmp1_;
#line 107 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp2_ = g_file_new_for_path ("/root");
#line 107 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (duplicity_job_slash_root);
#line 107 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_slash_root = _tmp2_;
#line 108 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp3_ = g_file_new_for_path ("/home");
#line 108 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (duplicity_job_slash_home);
#line 108 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_slash_home = _tmp3_;
#line 109 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp4_ = g_get_home_dir ();
#line 109 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_tmp5_ = g_file_new_for_path (_tmp4_);
#line 109 "../libdeja/tools/duplicity/DuplicityJob.vala"
		_g_object_unref0 (duplicity_job_slash_home_me);
#line 109 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_slash_home_me = _tmp5_;
#line 7863 "DuplicityJob.c"
	}
#line 104 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return obj;
#line 7867 "DuplicityJob.c"
}

static DuplicityJobDateInfo*
duplicity_job_date_info_dup (const DuplicityJobDateInfo* self)
{
	DuplicityJobDateInfo* dup;
#line 79 "../libdeja/tools/duplicity/DuplicityJob.vala"
	dup = g_new0 (DuplicityJobDateInfo, 1);
#line 79 "../libdeja/tools/duplicity/DuplicityJob.vala"
	memcpy (dup, self, sizeof (DuplicityJobDateInfo));
#line 79 "../libdeja/tools/duplicity/DuplicityJob.vala"
	return dup;
#line 7880 "DuplicityJob.c"
}

static void
duplicity_job_date_info_free (DuplicityJobDateInfo* self)
{
#line 79 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_free (self);
#line 7888 "DuplicityJob.c"
}

static GType
duplicity_job_date_info_get_type (void)
{
	static volatile gsize duplicity_job_date_info_type_id__volatile = 0;
	if (g_once_init_enter (&duplicity_job_date_info_type_id__volatile)) {
		GType duplicity_job_date_info_type_id;
		duplicity_job_date_info_type_id = g_boxed_type_register_static ("DuplicityJobDateInfo", (GBoxedCopyFunc) duplicity_job_date_info_dup, (GBoxedFreeFunc) duplicity_job_date_info_free);
		g_once_init_leave (&duplicity_job_date_info_type_id__volatile, duplicity_job_date_info_type_id);
	}
	return duplicity_job_date_info_type_id__volatile;
}

static void
duplicity_job_class_init (DuplicityJobClass * klass,
                          gpointer klass_data)
{
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	duplicity_job_parent_class = g_type_class_peek_parent (klass);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_type_class_adjust_private_offset (klass, &DuplicityJob_private_offset);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->start = (void (*) (DejaDupToolJob*)) duplicity_job_real_start;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->cancel = (void (*) (DejaDupToolJob*)) duplicity_job_real_cancel;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->stop = (void (*) (DejaDupToolJob*)) duplicity_job_real_stop;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->pause = (void (*) (DejaDupToolJob*, const gchar*)) duplicity_job_real_pause;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->resume = (void (*) (DejaDupToolJob*)) duplicity_job_real_resume;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_error = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_error;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_info = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_info;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_warning = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_warning;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_duplicity_job_get_property;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_duplicity_job_set_property;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->constructor = duplicity_job_constructor;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->finalize = duplicity_job_finalize;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUPLICITY_JOB_STATE_PROPERTY, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", DUPLICITY_JOB_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7937 "DuplicityJob.c"
}

static void
duplicity_job_instance_init (DuplicityJob * self,
                             gpointer klass)
{
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv = duplicity_job_get_instance_private (self);
#line 34 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->_error_issued = FALSE;
#line 35 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->_was_stopped = FALSE;
#line 53 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->is_full_backup = FALSE;
#line 54 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->cleaned_up_once = FALSE;
#line 55 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->needs_root = FALSE;
#line 56 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->detected_encryption = FALSE;
#line 57 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->existing_encrypted = FALSE;
#line 62 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->has_progress_total = FALSE;
#line 71 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->has_checked_contents = FALSE;
#line 72 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->has_non_home_contents = FALSE;
#line 73 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->homes = NULL;
#line 75 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->local_error_files = NULL;
#line 77 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->checked_collection_info = FALSE;
#line 78 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->got_collection_info = FALSE;
#line 83 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->collection_info = NULL;
#line 85 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->reported_full_backups = FALSE;
#line 87 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->checked_backup_space = FALSE;
#line 90 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->deleted_files = FALSE;
#line 91 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->delete_age = 0;
#line 93 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = NULL;
#line 94 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->forced_cache_dir = NULL;
#line 890 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self->priv->restarted_without_cache = FALSE;
#line 7990 "DuplicityJob.c"
}

static void
duplicity_job_finalize (GObject * obj)
{
	DuplicityJob * self;
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_network_get ();
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_parse_name ("notify::connected", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _duplicity_job_network_changed_g_object_notify, self);
#line 114 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp1_);
#line 48 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->inst);
#line 50 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->backend_argv == NULL) ? NULL : (self->priv->backend_argv = (_g_list_free__g_free0_ (self->priv->backend_argv), NULL));
#line 51 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->saved_argv == NULL) ? NULL : (self->priv->saved_argv = (_g_list_free__g_free0_ (self->priv->saved_argv), NULL));
#line 52 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->saved_envp == NULL) ? NULL : (self->priv->saved_envp = (_g_list_free__g_free0_ (self->priv->saved_envp), NULL));
#line 59 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->last_bad_volume);
#line 73 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->homes == NULL) ? NULL : (self->priv->homes = (_g_list_free__g_object_unref0_ (self->priv->homes), NULL));
#line 75 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->local_error_files == NULL) ? NULL : (self->priv->local_error_files = (_g_list_free__g_object_unref0_ (self->priv->local_error_files), NULL));
#line 83 "../libdeja/tools/duplicity/DuplicityJob.vala"
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
#line 93 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 94 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->forced_cache_dir);
#line 759 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->saved_status);
#line 760 "../libdeja/tools/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->saved_status_file);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (duplicity_job_parent_class)->finalize (obj);
#line 8039 "DuplicityJob.c"
}

GType
duplicity_job_get_type (void)
{
	static volatile gsize duplicity_job_type_id__volatile = 0;
	if (g_once_init_enter (&duplicity_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DuplicityJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) duplicity_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DuplicityJob), 0, (GInstanceInitFunc) duplicity_job_instance_init, NULL };
		GType duplicity_job_type_id;
		duplicity_job_type_id = g_type_register_static (DEJA_DUP_TYPE_TOOL_JOB, "DuplicityJob", &g_define_type_info, 0);
		DuplicityJob_private_offset = g_type_add_instance_private (duplicity_job_type_id, sizeof (DuplicityJobPrivate));
		g_once_init_leave (&duplicity_job_type_id__volatile, duplicity_job_type_id);
	}
	return duplicity_job_type_id__volatile;
}

static void
_vala_duplicity_job_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (property_id) {
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case DUPLICITY_JOB_STATE_PROPERTY:
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		g_value_set_enum (value, duplicity_job_get_state (self));
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		break;
#line 8072 "DuplicityJob.c"
		default:
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		break;
#line 8078 "DuplicityJob.c"
	}
}

static void
_vala_duplicity_job_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
	switch (property_id) {
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		case DUPLICITY_JOB_STATE_PROPERTY:
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		duplicity_job_set_state (self, g_value_get_enum (value));
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		break;
#line 8098 "DuplicityJob.c"
		default:
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../libdeja/tools/duplicity/DuplicityJob.vala"
		break;
#line 8104 "DuplicityJob.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

